!!$---------------------------------------------------------------------
SUBROUTINE MIE(E1,E2,LAM,RAD,beta,QEX,QSC,QAB,G)
!!$---------------------------------------------------------------------
!!$  Passed Variables
!!$    E1  : real part of optical property of the dust
!!$    E2  : imaginary part of optical property of the dust
!!$          (optical property follows the "n + i k" convension)
!!$    LAM : wavelength in microns
!!$    RAD : dust radius in microns
!!$    BETA: used approximation (default = 1)
!!$          [1] Strictly spherical particles
!!$          [2] CDE for small + large spheres
!!$          [3] CDE for small + large vol. equiv. spheres
!!$    QEX : Qext
!!$    QSC : Qsca
!!$    QAB : Qabs
!!$    G   : Asymmetry parameter, i.e., < cos(scattering angle) >
!!$---------------------------------------------------------------------
  USE PRCSN
  IMPLICIT NONE
!!$
  REAL(DBL), PARAMETER :: PID = 3.141592653589793228_DBL
!!$
  REAL(PRC), INTENT(IN) :: E1,E2,LAM,RAD
  INTEGER, INTENT(IN) :: BETA
  REAL(PRC), INTENT(OUT) :: QEX,QSC,QAB,G

  INTEGER :: NSTOP,YMOD,NMX,N,RN
  REAL(DBL) :: X,XSTOP,PSI0,PSI1,PSI,CHI0,CHI1,CHI,FN,DUM1,DUM2
  COMPLEX(DBL) :: M,Y,DUM,XI0,XI1,XI,AN,BN,AN0,BN0
  COMPLEX(DBL), ALLOCATABLE, DIMENSION(:) :: D

  X = 2.0_DBL * PID * RAD / LAM
  M = CMPLX(E1,E2,DBL)
  Y = M * X

!!$  Set number of recursion 
!!$    Rooij & van der Stap criterion
XSTOP = X + 4.05_DBL*(X**(0.33333333_DBL)) + 10.0_DBL
!!$    Wiscombe-Dave criterion
!!$  XSTOP = X + 4.00_DBL*(X**(0.33333333_DBL)) + 2.0_DBL
  NSTOP = ANINT(XSTOP)
  YMOD  = ANINT(ABS(Y))
  NMX   = MAX(NSTOP,YMOD) + 15

  ALLOCATE(D(NMX))
  D(NMX) = CMPLX(0.0,0.0,DBL)

  DO N=1,NMX-1
     RN         = NMX - N + 1
     DUM        = RN / Y
     D(NMX - N) = DUM - 1.0 / (D(NMX - N + 1) + DUM)
  END DO

  PSI0 = COS(X)
  PSI1 = SIN(X)

  CHI0 = -SIN(X)
  CHI1 = COS(X)

  XI0 = CMPLX(PSI0,-CHI0,DBL)
  XI1 = CMPLX(PSI1,-CHI1,DBL)

  QSC = 0.0_PRC
  QEX = 0.0_PRC
  G   = 0.0_PRC
  N   = 0
  
  DO WHILE (N <= NSTOP)
     N   = N + 1
     FN  = (2.0*N + 1.0) / (N*(N + 1.0))
     PSI = (2.0 * N - 1.0) * PSI1 / X - PSI0
     CHI = (2.0 * N - 1.0) * CHI1 / X - CHI0
     XI  = CMPLX(PSI,-CHI,DBL)

     AN  = D(N) / M + N / X 
     AN  = (AN * PSI - PSI1) / (AN * XI - XI1)

     BN  = M * D(N) + N / X
     BN  = (BN * PSI - PSI1) / (BN * XI - XI1)

     DUM1 = ABS(AN)
     DUM2 = ABS(BN)
     QSC  = QSC + (2.0*N + 1.0)*(DUM1*DUM1+DUM2*DUM2)
     QEX  = QEX + (2.0*N + 1.0)*REAL(AN + BN)

     IF (N > 1) THEN
        G = G &
             +(N-1.0)*(N+1.0)/N * REAL(AN0*CONJG(AN)+BN0*CONJG(BN)) &
             +(2.0*N-1.0)/((N-1.0)*N) * REAL(AN0*CONJG(BN0))
     END IF
     
     PSI0 = PSI1
     PSI1 = PSI

     CHI0 = CHI1
     CHI1 = CHI
     
     XI0  = XI1
     XI1  = XI

     AN0  = AN
     BN0  = BN
  END DO
  
  DUM1 = 2.0/(X*X)
  QSC  = QSC * DUM1
  QEX  = QEX * DUM1
  QAB  = QEX - QSC
  G    = G * 2.0 * DUM1 / QSC
  DEALLOCATE(D)
END SUBROUTINE MIE

!!$---------------------------------------------------------------------  
FUNCTION DFUNC(X,TH)
!!$---------------------------------------------------------------------  
  USE PRCSN
  USE CONST, ONLY : PI,PIO2
  USE DEFVARS, ONLY : A,B,C,D,E,THCRIT,RMIN
  IMPLICIT NONE
  REAL(PRC), INTENT(IN) :: X,TH
  REAL(PRC) :: DFUNC
  REAL(DBL) :: RATIO,COSTH,SINTH

  RATIO = X/RMIN
  IF (TH < PIO2) THEN
     COSTH = COS(TH)
  ELSE IF (TH > PIO2) THEN
     COSTH = -COS(TH)
  ELSE
     COSTH = 0.0_DBL
  END IF
  SINTH = SIN(TH)
  COSTH = COSTH*COSTH
  DFUNC = (RATIO**(-A))* &
       & ( B*EXP(-C*(RATIO**D)*COSTH) + &
       & E*SINTH*EXP(-THCRIT*COSTH))
  RETURN
END FUNCTION DFUNC

!!$---------------------------------------------------------------------
SUBROUTINE AGNPREP(MJTOT,DUM3,FnuSTAR,MJnu1,Inu1,LAMBDA,WT3,WT4,&
     CTHETA,Z,NK0,NRAD,NWAV,NQ,MXTH,SFLAG)
!!$---------------------------------------------------------------------
!!$  This subroutine adds the "AGN mode" to the 2-Dust code.
!!$  
!!$  In collaboration with R. Szczerba, Z. Loska, & B. Czerny at the
!!$  N. Copernicus Astronomical Institute of Poland.  
!!$                                         June 2003, Toshiya Ueta, ROB
!!$---------------------------------------------------------------------
!!$  AGN is represented here as an artificial central point source that
!!$  consists of the following two components;
!!$   (1) the disk component
!!$       this has the accretion disk spectrum (log(F_dsk)) whosse 
!!$       radiation is anisotropic and decreases with the cosine of the
!!$       inclination angle
!!$   (2) the spherical component
!!$       this has a power law spectrum (log(F_sph))
!!$
!!$  This subroutine needs "sourceflux.dat" with the following format
!!$   line 1-2: blank
!!$   line 3  : Rdsk, Rsph in AU
!!$   line 4-8: blank
!!$   line 9- : log(lam[um]), log(I_dsk[cgs]), log(I_sph[cgs])
!!$---------------------------------------------------------------------
  USE DEFVARS
!!$
  IMPLICIT NONE
!!$
  INTEGER, INTENT(IN)                      :: NRAD,NWAV,NQ,MXTH,SFLAG
  REAL(PRC), DIMENSION(NWAV), INTENT(IN)   :: LAMBDA,WT3,WT4
  REAL(PRC), DIMENSION(0:NQ), INTENT(IN)   :: CTHETA
  REAL(PRC), DIMENSION(NQ), INTENT(IN)     :: Z
  INTEGER, DIMENSION(0:NRAD+1), INTENT(IN) :: NK0
!!$
  REAL(PRC), INTENT(INOUT)                   :: MJTOT,DUM3
  REAL(PRC), DIMENSION(MXTH,NWAV,0:NRAD+1,0:2*NQ+1), INTENT(INOUT) :: &
       Inu1
  REAL(PRC), DIMENSION(NWAV,0:NRAD+1,0:2*NQ+1), INTENT(INOUT)      :: &
       FnuSTAR,MJnu1
!!$  
  CHARACTER(30) :: DUMMY
!!$
  INTEGER :: IOFLAG,IERROR,I,II,M,K,L,NPTS,NQ2
!!$
  REAL(PRC) :: DUM1,DUM2,F1,F2,RDUM,RDSK,RSPH,LS,DOMEGA,AA,BB
!!$
  REAL(PRC), ALLOCATABLE, DIMENSION(:,:)     :: DUMARR1,DUMARR2,DUMARR3
!!$
  NQ2 = 2*NQ+1
!!$
  OPEN(UNIT=30,FILE='datafiles.dat',STATUS='OLD',IOSTAT=IERROR)
  READ(30,*) IOFLAG
  CLOSE(30)
  IF (IOFLAG == 0) THEN
     WRITE(*,'(" Invoking the AGN mode... ")')
     WRITE(*,'("   ... reading sourceflux.dat ")')
     WRITE(*,'(" ")')
  END IF
  ALLOCATE(DUMARR1(3,NDUM),STAT=IERROR)
  DUMARR1 = 0.0_PRC
  OPEN(UNIT=30,FILE='sourceflux.dat',STATUS='OLD',IOSTAT=IERROR)
  READ(30,'(A30)') DUMMY
  READ(30,'(A30)') DUMMY
  READ(30,*)       RDSK,RSPH ! in AU
  RDSK  = RDSK * AU ! in cm
  RSPH  = RSPH * AU ! in cm
  READ(30,'(A30)') DUMMY
  READ(30,'(A30)') DUMMY
  READ(30,'(A30)') DUMMY
  READ(30,'(A30)') DUMMY
  READ(30,'(A30)') DUMMY
  I = 0
  DO II=1,NDUM
     READ(30,*,IOSTAT=IERROR) DUM1,DUM2,F1
     IF (IERROR < 0.0_PRC) EXIT
     I = I + 1
     DUMARR1(1,II) = 10.0_PRC**DUM1 ! lambda in um
     F2 = LOG10(DUMARR1(1,II)*DUMARR1(1,II)/CSP)
     IF (DUM2 /= 0.0_PRC) THEN
        DUMARR1(2,II) = DUM2 + F2 ! I_disk in log(I_nu)
     ELSE
        DUMARR1(2,II) = 0.0_PRC
     END IF
     IF (F1 /= 0.0_PRC) THEN
        DUMARR1(3,II) = F1   + F2 ! I_sph  in log(I_nu)
     ELSE
        DUMARR1(3,II) = 0.0_PRC
     END IF
  END DO
  CLOSE(UNIT=30)
  NPTS = I
!!$
!!$  Copy only the filled part of the DUMARR1 into DUMARR3
!!$   and invert the order to ascending order for interpolation
!!$
  ALLOCATE(DUMARR3(4,NPTS), STAT=IERROR)
  DUMARR3 = 0.0_PRC
  DO M=1,3
     DO II=1,NPTS
        DUMARR3(M,II) = DUMARR1(M,NPTS-II+1)
     END DO
  END DO
  DEALLOCATE(DUMARR1,STAT=IERROR) ! no longer needed
  
!!$  DO II=1,NPTS
!!$     write(*,*) DUMARR3(1,ii),DUMARR3(2,ii),DUMARR3(3,ii)
!!$     write(51,*) DUMARR3(1,ii),DUMARR3(2,ii),DUMARR3(3,ii)
!!$  END DO
  
!!$---------------------------------------------------------------------  
!!$  Interpolate log(l_dsk[cgs]) and log(l_sph[cgs]) values
!!$  at the wavelengths specified in the specgrid.dat
!!$---------------------------------------------------------------------  
  ALLOCATE(DUMARR2(3,NWAV),STAT=IERROR)
  DUMARR2 = 0.0_PRC
  RDUM = 1.0E+30_PRC
  DO M = 2,3
     CALL SPLINE(DUMARR3(1,:),DUMARR3(M,:),NPTS,RDUM,RDUM,&
          DUMARR3(4,:))
     DO II=1,NWAV
        DUMARR2(1,II) = LAMBDA(II)
        CALL SPLINT(DUMARR3(1,:),DUMARR3(M,:),DUMARR3(4,:),NPTS,&
             LAMBDA(II),DUMARR2(M,II))
     END DO
  END DO
  
  OPEN(UNIT=30,FILE='sourcefluxout.dat',STATUS='unknown',IOSTAT=IERROR)
  WRITE(30,'(2ES22.13)') RDSK,RSPH ! in cm
  DO II = 1,NWAV
!!$        write(*,'(3ES22.13)') DUMARR2(1,II),DUMARR2(2,II),DUMARR2(3,II)
!!$        write(52,'(3ES22.13)') DUMARR2(1,II),DUMARR2(2,II),DUMARR2(3,II)
     DUM1 = DUMARR2(2,II)
     DUM2 = DUMARR2(3,II)
     IF (DUM1 /= 0.0_PRC) THEN
        DUMARR2(2,II) = (10.0_PRC**DUMARR2(2,II))* &
             (RDSK/RSPH)*(RDSK/RSPH)
     ELSE
        DUMARR2(2,II) = 0.0_PRC
     END IF
     IF (DUM2/= 0.0_PRC) THEN
        DUMARR2(3,II) = 10.0_PRC**DUMARR2(3,II)
     ELSE
        DUMARR2(3,II) = 0.0_PRC
     END IF
!!$        WRITE(*,'(3ES22.13)') DUMARR2(1,II),DUMARR2(2,II),DUMARR2(3,II)
        WRITE(30,'(3ES22.13)') DUMARR2(1,II),DUMARR2(2,II),DUMARR2(3,II)
  END DO
  CLOSE(UNIT=30)
  DEALLOCATE(DUMARR3,STAT=IERROR)
!!$---------------------------------------------------------------------  
!!$  Now input lat-dependent source rad field is set up
!!$    DUMARR2(1,NWAV) = lambda in um
!!$    DUMARR2(2,NWAV) = I_nu,dsk scaled to RSPH in cgs
!!$    DUMARR2(3,NWAV) = I_nu,sph in cgs
!!$  and these values along with R_dsk and R_sph are written in a file
!!$  called "sourcefluxout.dat".      
!!$---------------------------------------------------------------------  
!!$  Now integrate the source rad field to get luminosity
!!$---------------------------------------------------------------------  
  DUM1   = STARRADIUS/RMIN
  DOMEGA = PI * DUM1 * DUM1
  DUM3   = 0.0_PRC
  DO II = 1,NWAV
!!$     First set FnuSTAR and MJnu1 along the axis
!!$       Input intensity is at the surface of the source, and
!!$       thus need to dilute by "DOMEGA"
     LS = (CTHETA(0) * DUMARR2(2,II) + DUMARR2(3,II)) * DOMEGA 
     FnuSTAR(II,0,0)   = LS
     FnuSTAR(II,0,NQ2) = FnuSTAR(II,0,0)
     MJnu1(II,0,0)     = LS/FOURPI ! meanintensity
     MJnu1(II,0,NQ2)   = MJnu1(II,0,0)
!!$     Then set FnuSTAR and MJnu1 for THETA(NQ2) angles
!!$       Input intensity is at the surface of the source, and
!!$       thus need to be diluted by "DOMEGA"
     BB = 0.0_PRC
     AA = 0.0_PRC
     DO M=1,NQ
        LS = CTHETA(M) * DUMARR2(2,II) + DUMARR2(3,II)
!!$        write(*,*) II,M,LS,CTHETA(M),DUMARR2(2,II),DUMARR2(3,II)
        BB = BB + LS * Z(M)  
        LS = LS * DOMEGA
        FnuSTAR(II,0,M)     = LS
        FnuSTAR(II,0,NQ2-M) = FnuSTAR(II,0,M)
        LS                  = LS / FOURPI
        AA                  = AA + LS * Z(M)
        MJnu1(II,0,M)       = LS
        MJnu1(II,0,NQ2-M)   = MJnu1(II,0,M)
!!$     Initially anisotropic radiation field not supported yet.
!!$     So, make the initial field isotropic
        IF (SFLAG == 1) THEN
           DO L=0,NRAD+1
              DO K=1,NK0(L)
                 Inu1(K,II,0,M)     = MJnu1(II,0,M)
                 Inu1(K,II,0,NQ2-M) = Inu1(K,II,0,M)
              END DO
           END DO
        END IF
     ENDDO    
!!$     Below, DUM1 is B_nu (theta, phi) being integrated over the 
!!$     entire wavelength range.  The factor "4 PI" consists of "2 PI"
!!$     for the phi angle integration (azimuthal symmetry) and "2" for 
!!$     the fact that the radiation field is symmetric w.r.t. the 
!!$     equatorial plane (we calculated above for the half sphere).
!!$
!!$     MJTOT will be needed to estimate how much radiation is due to
!!$     star and how much is due to dust.  We do exactly the same 
!!$     integration for MJTOT as DUM1 but then MJTOT is "mean"intensity
!!$     averaged over "4 PI" radians.  So, no factor "4 PI" here.
     DUM3  = DUM3  + WT4(II) * BB * FOURPI ! BB for half-sphere
     MJTOT = MJTOT + WT3(II) * AA
  END DO
  DEALLOCATE(DUMARR2,STAT=IERROR)  
END SUBROUTINE AGNPREP

!!$---------------------------------------------------------------------  
SUBROUTINE MINDENS(RLAYER,KK,AVGMASS,NWAV,NZONE,TAU0,N0,NQ,DFLAG,RHOMIN)
!!$---------------------------------------------------------------------  
!!$    "Density" can mean both mass and number density here, and the 
!!$    user input parameter DFLAG (specified in the input parameter list) 
!!$    will decide what we mean by "density".  The dinut will assume 
!!$    mass/number density is continuous according to the selection.
!!$
!!$       DFLAG = 0 : mass density (g cm^-3) will be continuous
!!$       DFLAG = 1 : number density (cm^-3) will be continuous
!!$
!!$    Mass density should be continuous if one is considering a shell
!!$    with compositional changes but wants to keep the gas-to-mass 
!!$    ratio the same throughout, for example.
!!$
!!$    Number density is continuous if one is considering compositional
!!$    changes in a shell in which grains are formed according to the 
!!$    heterogeneous nucleation theory, for example.
!!$
!!$    In the main radiative transfer calculations, "density" has to
!!$    be number density because we use cross sections (cm^2) and not
!!$    opacities (cm^2 g^-1).
!!$
!!$    The following calculates the "density" at the inner boundary at
!!$    the equator.  The innermost density is determined from the choice 
!!$    of optical thickness of the (entire) shell for the chosen 
!!$    wavelength (TAU0 and N0 parameters).
!!$
!!$    The input NQ is the number of quadrature points for integration.
!!$
!!$      RHOMIN : density @ Rmin on the equator
!!$---------------------------------------------------------------------
  USE PRCSN
  USE DEFVARS, ONLY : PIO2,RMIN
!!$
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: NZONE,NWAV,DFLAG,N0,NQ
  REAL(PRC), INTENT(IN) :: TAU0
  REAL(PRC), DIMENSION(0:NZONE), INTENT(IN) :: RLAYER
  REAL(PRC), DIMENSION(NZONE), INTENT(IN) :: AVGMASS
  REAL(PRC), DIMENSION(NWAV,NZONE), INTENT(IN) :: KK
  REAL(PRC), INTENT(OUT) :: RHOMIN

  REAL(PRC), ALLOCATABLE, DIMENSION(:) :: PTS,WTS

  INTEGER :: I,K,IERROR,NQUAD
  REAL(PRC) :: DUM1

  REAL(PRC), EXTERNAL :: DFUNC

  NQUAD = NQ*NQ
!!$---------------------------------------------------------------------
!!$  Determine "density" @ Rmin (RHOMIN) along the equator
!!$---------------------------------------------------------------------
  RHOMIN = 0.0_PRC
  ALLOCATE(PTS(NQUAD),STAT=IERROR)
  ALLOCATE(WTS(NQUAD),STAT=IERROR)
  IF (DFLAG == 0) THEN
     DO K=1,NZONE
        DUM1 = 0.0_PRC
        CALL GAULEG(RLAYER(K-1),RLAYER(K),PTS,WTS,NQUAD)
        DO I=1,NQUAD
           DUM1 = DUM1 + WTS(I)*DFUNC(PTS(I),PIO2)
        END DO
!!$        write(*,*) RLAYER(K-1),RLAYER(K),DUM1,KK(N0,K),AVGMASS(K)
        RHOMIN = RHOMIN + (KK(N0,K)/AVGMASS(K))*DUM1
     END DO
  ELSE
     DO K=1,NZONE
        DUM1 = 0.0_PRC
        CALL GAULEG(RLAYER(K-1),RLAYER(K),PTS,WTS,NQUAD)
        DO I=1,NQUAD
           DUM1 = DUM1 + WTS(I)*DFUNC(PTS(I),PIO2)
        END DO
!!$        write(*,*) RLAYER(K-1),RLAYER(K),DUM1,KK(N0,K),AVGMASS(K)
        RHOMIN = RHOMIN + KK(N0,K)*DUM1
     END DO
  END IF
  DEALLOCATE(PTS,WTS)
  RHOMIN = TAU0/RHOMIN
!!$  write(*,*) TAU0,N0,RHOMIN
!!$---------------------------------------------------------------------
!!$  RHOMIN is mass density if DFLAG=0 or number density if DFLAG=1
!!$---------------------------------------------------------------------
!!$  Done determining "density" @ Rmin at the equator
!!$---------------------------------------------------------------------
END SUBROUTINE MINDENS

!!$---------------------------------------------------------------------
SUBROUTINE DUSTPREP(NWAV,NZONE,KAPPA,SIGMA,ASYMP,LAMBDA,AVGMASS,NGTYPE,&
     NFLAG)
!!$---------------------------------------------------------------------
!!$  This subroutine calculates absorption and scattering cross sections
!!$  from a given set of initial dust property parameters.  The computed
!!$  cross sections are written in the XSEC file, whose name is defined
!!$  at the 7th line in the 'datafiles.dat' file.  Alternately, a user
!!$  can read in precalculated values in XSEC file.  In this case,
!!$  the XSEC definition defines the file name to be read in.
!!$  
!!$  When calculating cross sections, a dust property (PROPS) file is
!!$  required.  The PROPS file name is defined at the 6th line of the
!!$  'datafiles.dat' file.  The PROPS file should have the following
!!$  information in the shown format:
!!$     line
!!$      (1)  1  1 
!!$      (2)  2 
!!$      (3)  1  3.2  0.50  3.5  0.001  1.0   nk_dorschner95_olmg40.dat
!!$      (4)  1  3.2  0.50  3.5  0.001  1.0   nk_dwsuvSil.optical_rev
!!$      col (1) (2)  (3)   (4)   (5)   (6)   (7)
!!$   Explanation of the lines and columns
!!$     line(1) there are two flags.
!!$         1st: XFLAG - if 0, the existing XSEC file is read
!!$                      if 1, cross sections will be computed by
!!$                      mie theory and are written to a XSEC file.
!!$         2nd: NFLAG - normalization scheme for size space averaging
!!$                      if 0, n(a) is a simple MRN or KMH
!!$                      if 1, n(a) is MRN or KMH weighted over the 
!!$                      grain surface (multiplied by PI a^2)
!!$                      for the above 2 options, averaging method is 
!!$                      weighted arithmetic mean
!!$                      if 2, the temperature is expanded for each
!!$                      size and species, which is good to follow
!!$                      contribution by each species (averaging method
!!$                      follows those in the QHEAT mode - see below).
!!$                      if 3, the quantum heating mode is invoked.
!!$                      The QHEAT option uses weighted geometric mean
!!$                      and the Harrington type average of dust properties
!!$                      i.e., n(a) is MRN or KMH weighted over the 
!!$                      grain surface (multiplied by PI a^2).
!!$     line(2) number of dust species in the next layer
!!$     line(3) dust peoperty parameters for species #1
!!$         col(1) size distribution type
!!$            [1] MRN size distribution
!!$            [2] KMH size distribution
!!$         col(2) bulk density of the dust species (g cm^-3)
!!$         col(3) mass % weight of the species (the sum has to be 1.0)
!!$         col(4) gamma factor in the size distribution
!!$         col(5) minimum grain radius (microns)
!!$         col(6) maximum grain radius in MRN or
!!$                a_0 exponentioal fall-off factor in KMH (microns)
!!$         col(7) n & k file name (lam(microns)  n  k - format)
!!$                the mie algorithm used in this subroutine assumes
!!$                N = n + i k
!!$            NB: the entire wavelength range for donut calculation 
!!$                must be covered by the file.
!!$     line(4) dust peoperty parameters for species #2
!!$    ..continues for all specied for this layer 
!!$    ..repeats lines for all layers
!!$
!!$  When done, there will be four arrays containin the following
!!$  quantities:
!!$    KAPPA(WAV,ZONE) : absorption cross section (cm^2)
!!$    SIGMA(WAV,ZONE) : scattering cross section (cm^2)
!!$    ASYMP(WAV,ZONE) : asymmetry parameter
!!$    AVGMASS(ZONE)   : size & composition averaged grain mass (g)
!!$  KAPPA, SIGMA, & ASYMP are all size & composition averaged for each
!!$  zone for each wavelength
!!$---------------------------------------------------------------------
  USE DEFVARS
!!$---------------------------------------------------------------------
  IMPLICIT NONE
!!$---------------------------------------------------------------------
  INTEGER,                          INTENT(IN)    :: NWAV,NZONE
  REAL(PRC), DIMENSION(NWAV,NZONE), INTENT(INOUT) :: KAPPA,SIGMA,ASYMP
  REAL(PRC), DIMENSION(NWAV),       INTENT(INOUT) :: LAMBDA
  REAL(PRC), DIMENSION(NZONE),      INTENT(INOUT) :: AVGMASS
  INTEGER,   DIMENSION(NZONE),      INTENT(OUT)   :: NGTYPE
  INTEGER,                          INTENT(OUT)   :: NFLAG
!!$---------------------------------------------------------------------
  CHARACTER     :: CKFLG
  CHARACTER(30) :: PROPS,XSEC,DUMMY
!!$---------------------------------------------------------------------
  INTEGER :: I,NZ,NG,NW,N,NPTS,BETA,MXTY,OLDNFLAG
  INTEGER :: IOFLAG,XFLAG,IERROR,PLEN,XLEN,MXNK
!!$---------------------------------------------------------------------
  REAL(PRC) :: RDUM,GAM,GAM1,SUM1,SUM2,SUM3,FAC,QE,QA,QS,GE
  REAL(PRC) :: PTSCM,WTSCM
!!$---------------------------------------------------------------------
  CHARACTER(30), ALLOCATABLE, DIMENSION(:,:) :: NKFILE
!!$---------------------------------------------------------------------
  INTEGER, ALLOCATABLE, DIMENSION(:)   :: NPAH
  INTEGER, ALLOCATABLE, DIMENSION(:,:) :: SDTYPE,NNK
!!$---------------------------------------------------------------------
  REAL(PRC), ALLOCATABLE, DIMENSION(:)     :: WTS1,PTS1
  REAL(PRC), ALLOCATABLE, DIMENSION(:)     :: N1,K1,NIN,KIN,LAMIN
  REAL(PRC), ALLOCATABLE, DIMENSION(:,:)   :: RHOGR,MASSWT,NUMWT,GAMMA2
  REAL(PRC), ALLOCATABLE, DIMENSION(:,:)   :: AMIN,AMAX,NORMFAC
  REAL(PRC), ALLOCATABLE, DIMENSION(:,:)   :: GMASS,GSIZE
  REAL(PRC), ALLOCATABLE, DIMENSION(:,:)   :: DUMARR3,DUMARR4,DUMARR5
  REAL(PRC), ALLOCATABLE, DIMENSION(:,:)   :: DUMARR6
  REAL(PRC), ALLOCATABLE, DIMENSION(:,:,:) :: KAPEXP,SIGEXP,GEEEXP
  REAL(PRC), ALLOCATABLE, DIMENSION(:,:,:) :: DUMARR1,DUMARR2
  REAL(PRC), ALLOCATABLE, DIMENSION(:,:,:) :: N2,K2,APTS,AWTS,N2C,K2C
  REAL(PRC), ALLOCATABLE, DIMENSION(:,:,:,:) :: QABS,QSCA,GEEE
!!$---------------------------------------------------------------------
  CHARACTER(23), DIMENSION(2) :: NKFILEC = &
       (/ 'graphite_para_ld93.optc','graphite_perp_ld93.optc' /)
!!$---------------------------------------------------------------------
!!$  Retrieve Grain Properties Filenames
!!$---------------------------------------------------------------------
  OPEN(UNIT=30,FILE='datafiles.dat',STATUS='OLD',IOSTAT=IERROR)
  READ(30,*) IOFLAG    ! file I/O flag
  READ(30,'(A)') DUMMY
  READ(30,'(A)') DUMMY
  READ(30,'(A)') DUMMY
  READ(30,'(A)') DUMMY
  READ(30,'(A)') PROPS ! dust grain properties file
  READ(30,'(A)') XSEC  ! cross sections file
  CLOSE(UNIT=30)
!!$---------------------------------------------------------------------
!!$  Done Retrieving Grain Properties Filenames
!!$---------------------------------------------------------------------

!!$---------------------------------------------------------------------
!!$  Read Grain Property Input File
!!$---------------------------------------------------------------------
  PLEN = LEN_TRIM(PROPS)
  WRITE(PROPS(PLEN+1:PLEN+4),'(".dat")')
  IF (IOFLAG == 0) THEN ! Resolve the file name
     WRITE(*,'(" Retrieving Dust Property Parameters... ")')
     DO
        PLEN = LEN_TRIM(PROPS)
        WRITE(*,10) PROPS(1:PLEN)
        WRITE(*,11,advance='no')
        READ(*,'(A)') CKFLG 
        IF (CKFLG == ' ' .OR. CKFLG == "y" .OR. CKFLG == "Y") THEN
           EXIT
        ELSE
           WRITE(*,12,advance='no') PROPS(1:PLEN)
           READ(*,'(A30)') DUMMY
           IF (DUMMY == ' ') THEN
              PROPS = PROPS
           ELSE
              PROPS = DUMMY
           END IF
        END IF
     END DO
     WRITE(*,13)
  END IF
!!$---------------------------------------------------------------------
!!$  XSEC and NORMALIZATION flags
!!$---------------------------------------------------------------------
!!$    If XFLAG = 0, then read cross sections from XSEC file.
!!$    If XFLAG = 1, then read the rest of the PROPS file to get dust 
!!$     property parameters for later use in calculating cross sections.
!!$---------------------------------------------------------------------
!!$    If NFLAG = 0, then use "n(a)" as a normalization function.  
!!$    If NFLAG = 1, then use "PI a^2 n(a)" as a normalization function.
!!$    (size distribution is weighted over the surface area and
!!$     averaged values are of arithmetic mean.)
!!$    If NFLAG = 2/3, then the quantum heating method is invoked (in 
!!$    which the averaging method is the same as 1 for the grain 
!!$    properties but geometric mean is taken for everything else).
!!$---------------------------------------------------------------------
  OPEN(UNIT=30,FILE=PROPS,STATUS='old',IOSTAT=IERROR)
  READ(30,*) XFLAG, NFLAG
  DO NZ=1,NZONE ! Just read NGTYPE, repeating NZ times
     READ(30,*) NGTYPE(NZ)
     DO NG=1,NGTYPE(NZ)
        READ(30,*) DUMMY ! skip other things for now
     END DO
  END DO
  CLOSE(30)
  MXTY = MAXVAL(NGTYPE)    ! Get the max NGTYPE in the shell
  IF (NFLAG == 2) THEN
     NFLAG = 3 ! force Harrington method in expanded RT/QHEAT
     OLDNFLAG = 2
  ELSE
     OLDNFLAG = NFLAG
  END IF
!!$---------------------------------------------------------------------
!!$  Read the rest of the Grain Property Input File
!!$---------------------------------------------------------------------
  IF (XFLAG == 1) THEN
!!$---------------------------------------------------------------------
!!$  Define parameter arrays
!!$---------------------------------------------------------------------
!!$    SDTYPE(GTYPE,ZONE)  is the size distribution type of the species:
!!$      [1] MRN distribution (Amin to Amax)
!!$      [2] KMH distribution (with exponential fall-off)
!!$    RHOGR(GTYPE,ZONE)   is bulk density of the species (g cm^-3)
!!$    MASSWT(GTYPE,ZONE)  is mass % weight of the species in that ZONE
!!$    NUMWT(GTYPE,ZONE)   is # % weight of the species in that ZONE
!!$    GAMMA2(GTYPE,ZONE)  is the exp factor in the size distribution
!!$    AMIN(GTYPE,ZONE)    is a_min in the size distribution (um)
!!$    AMAX(GTYPE,ZONE)    is a_max/a_o in the size distribution (um)
!!$    NKFILE(GTYPE,NZONE) is the n&k file name for that species 
!!$---------------------------------------------------------------------
     ALLOCATE(SDTYPE(MXTY,NZONE),STAT=IERROR)
     ALLOCATE(RHOGR(MXTY,NZONE), STAT=IERROR)
     ALLOCATE(MASSWT(MXTY,NZONE),STAT=IERROR)
     ALLOCATE(NUMWT(MXTY,NZONE), STAT=IERROR)
     ALLOCATE(GAMMA2(MXTY,NZONE),STAT=IERROR)
     ALLOCATE(AMIN(MXTY,NZONE),  STAT=IERROR)
     ALLOCATE(AMAX(MXTY,NZONE),  STAT=IERROR)
     ALLOCATE(NKFILE(MXTY,NZONE),STAT=IERROR)
!!$---------------------------------------------------------------------
     SDTYPE = 1
     RHOGR  = 0.0_PRC
     MASSWT = 0.0_PRC     
     NUMWT  = 0.0_PRC
     GAMMA2 = 0.0_PRC
     AMIN   = 0.0_PRC
     AMAX   = 0.0_PRC
!!$---------------------------------------------------------------------
     OPEN(UNIT=30,FILE=PROPS,STATUS='old',IOSTAT=IERROR)
     READ(30,*) DUMMY
     DO NZ=1,NZONE
        READ(30,*) DUMMY
        DO NG=1,NGTYPE(NZ) ! read the rest of the input parameters
           READ(30,*) SDTYPE(NG,NZ),RHOGR(NG,NZ),MASSWT(NG,NZ), &
                GAMMA2(NG,NZ),AMIN(NG,NZ),AMAX(NG,NZ),NKFILE(NG,NZ)
!!$        When gamma2 = 3 or 4, integration breaks down
!!$        So, get around that by adding 1.0e-6
           IF (GAMMA2(NG,NZ)==3.0_PRC.OR.GAMMA2(NG,NZ)==4.0_PRC) &
                GAMMA2(NG,NZ)= GAMMA2(NG,NZ)+1.0e-6_PRC
           IF (SDTYPE(NG,NZ) /= 1 .AND. SDTYPE(NG,NZ) /= 2) THEN
              WRITE(*,'(" Error: Size distribution other than &
                  &MRN and KMH ")')
              WRITE(*,'("        are not implemented! ")')
              STOP
           END IF
        END DO
     END DO
     CLOSE(30)
!!$---------------------------------------------------------------------
!!$  Check if sum of MASSWT equals to 1 
!!$---------------------------------------------------------------------
     IF ((SUM(SUM(MASSWT,1))-FLOAT(NZONE))>1.0e-6_PRC) THEN
        WRITE(*,'(" Error: Mass weights do not add up!! ")')
        WRITE(*,'("  Quitting... ")')
        STOP
     END IF
!!$---------------------------------------------------------------------
!!$  Set PAH grain properties: Li & Draine 2001, ApJ 554, 778
!!$     a_min = 3.5 A
!!$     a_max = 100 A  -> i.e., PAH size distribution is MRN
!!$     rho   = 2.24 g/cc
!!$---------------------------------------------------------------------
     DO NZ = 1,NZONE
        DO NG = 1,NGTYPE(NZ)
           IF (TRIM(NKFILE(NG,NZ))=='PAH') THEN
              SDTYPE(NG,NZ) = 1           ! Must be MRN distribution
              AMIN(NG,NZ)   = 0.00035_PRC ! 3.5 A
!!$              AMAX(NG,NZ)   = 0.01_PRC    ! 100 A
              RHOGR(NG,NZ)  = 2.24_PRC    ! 2.24 g/cc
!!$              IF (IOFLAG == 0) THEN
!!$                 WRITE(*,'("  Forcing PAH dust properties ")')
!!$              END IF
           END IF
        END DO
     END DO
!!$---------------------------------------------------------------------
!!$  Done setting PAH properties
!!$---------------------------------------------------------------------
  END IF
!!$---------------------------------------------------------------------
!!$  Done Reading Grain Property Input File
!!$---------------------------------------------------------------------

!!$---------------------------------------------------------------------
!!$  Get Cross Sections (if XFLAG = 0)
!!$---------------------------------------------------------------------
  IF (XFLAG == 0) THEN ! resolve the XSEC file name
     XLEN = LEN_TRIM(XSEC)
     WRITE(XSEC(XLEN+1:XLEN+4),'(".dat")')
     IF (IOFLAG == 0) THEN ! interactive mode
        WRITE(*,'(" Retrieving Cross Sections ... ")')
        DO
           XLEN = LEN_TRIM(XSEC)
           WRITE(*,10) XSEC(1:XLEN)
           WRITE(*,11,advance='no')
           READ(*,'(A)') CKFLG 
           IF (CKFLG == ' ' .OR. CKFLG == "y" .OR. CKFLG == "Y") THEN
              OPEN(UNIT=31,FILE=XSEC,STATUS='OLD',IOSTAT=IERROR)
              IF (IERROR /= 0) THEN
                 write(*,'("  Error opening the file!  Try again! ")')
              ELSE
                 WRITE(*,13)
!!$---------------------------------------------------------------------
!!$  Read XSEC file 
!!$---------------------------------------------------------------------
                 DO NZ=1,NZONE
                    READ(31,*) AVGMASS(NZ)
                    write(*,19) AVGMASS(NZ)
                    DO NW=1,NWAV
                       READ(31,*) RDUM,KAPPA(NW,NZ),SIGMA(NW,NZ),&
                            ASYMP(NW,NZ)
                       write(*,20) RDUM,KAPPA(NW,NZ),SIGMA(NW,NZ),&
                            ASYMP(NW,NZ)
                    END DO
                 END DO
                 CLOSE(UNIT=31)
                 WRITE(*,11,advance='no')
                 READ(*,'(A)') CKFLG 
                 IF (CKFLG == ' ' .OR. CKFLG == "y" .OR. CKFLG == "Y") EXIT
              END IF
           ELSE
              WRITE(*,12) XSEC(1:XLEN)
              READ(*,'(A30)') DUMMY
              IF (DUMMY == ' ') THEN
                 XSEC = XSEC
              ELSE
                 XSEC = DUMMY
              END IF
           END IF
        END DO
        WRITE(*,13)
     ELSE ! non-interactive mode
        OPEN(UNIT=31,FILE=XSEC,STATUS='OLD',IOSTAT=IERROR)
        DO NZ=1,NZONE
           READ(31,*) AVGMASS(NZ)
           DO NW=1,NWAV
              READ(31,*) RDUM,KAPPA(NW,NZ),SIGMA(NW,NZ),ASYMP(NW,NZ)
           END DO
        END DO
        CLOSE(UNIT=31)
     END IF
  ELSE
!!$---------------------------------------------------------------------
!!$  Calculate the normalization factor for the size space integration
!!$---------------------------------------------------------------------
!!$    Calculate the normalization factor (NORMFAC(GTYPE,ZONE)) of
!!$       [1] the MRN size distribution 
!!$           AMAX
!!$           |                         -GAMMA2
!!$            |  n(a) da where n(a) = a
!!$             |
!!$           AMIN
!!$       [2] the KMH size distribution 
!!$          Infinity
!!$           |                        -GAMMA2  (-a/AMAX)
!!$            |  n(a) da where n(a)= a        e         
!!$             |
!!$           AMIN
!!$    by means of the Gaussian-Legendre Quadrature Integration.
!!$    
!!$    Also, when NFLAG = 1 or 3, n(a) is multiplied by "PI a^2", and 
!!$    thus, the normalization function becomes the size distribution 
!!$    weighted over the surface area of grains.  This is based on the
!!$    method presented by Harrington, Monk, & Clegg 1988, MNRAS, 231, 
!!$    577
!!$---------------------------------------------------------------------
     ALLOCATE(NORMFAC(MXTY,NZONE),       STAT=IERROR)
     ALLOCATE(PTS1(NSIZE),               STAT=IERROR)
     ALLOCATE(WTS1(NSIZE),               STAT=IERROR)
     ALLOCATE(APTS(0:NSIZE+1,MXTY,NZONE),STAT=IERROR)
     ALLOCATE(AWTS(NSIZE,MXTY,NZONE),    STAT=IERROR)
!!$---------------------------------------------------------------------
     NORMFAC = 1.0_PRC
     PTS1    = 0.0_PRC
     WTS1    = 0.0_PRC
     APTS    = 0.0_PRC
     AWTS    = 0.0_PRC
!!$---------------------------------------------------------------------
     APTS(0,      :,:) = AMIN * 1.0E-04_PRC ! from um to cm
     APTS(NSIZE+1,:,:) = AMAX * 1.0E-04_PRC ! from um to cm
     DO NZ=1,NZONE
        DO NG=1,NGTYPE(NZ)
           IF (SDTYPE(NG,NZ) == 1) THEN
              RDUM = exp(-APTS(0,NG,NZ)/APTS(NSIZE+1,NG,NZ))
              CALL GAULEG(0.0_PRC,RDUM,PTS1,WTS1,NSIZE)
              APTS(1:NSIZE,NG,NZ) = PTS1*1.0E-04_PRC ! from um to cm
              AWTS(1:NSIZE,NG,NZ) = WTS1*1.0E-04_PRC ! from um to cm
           ELSE
              RDUM = EXP(-1.0_PRC * AMIN(NG,NZ)/AMAX(NG,NZ))
              CALL GAULEG(0.0_PRC,RDUM,PTS1,WTS1,NSIZE)
              APTS(1:NSIZE,NG,NZ) = PTS1
              AWTS(1:NSIZE,NG,NZ) = WTS1
           END IF
        END DO
     END DO
     IF (NFLAG == 0) THEN
        WHERE (SDTYPE == 1) ! MRN 
           NORMFAC = 1.0_PRC - GAMMA2
           NORMFAC = &
                ((APTS(NSIZE+1,:,:)**NORMFAC)-(APTS(0,:,:)**NORMFAC))/ &
                NORMFAC
        ELSEWHERE ! KMH
           NORMFAC = SUM(AWTS * &
                ((-LOG(APTS(1:NSIZE,:,:)))**SPREAD(-GAMMA2,1,NSIZE)),1)
           NORMFAC = NORMFAC * APTS(NSIZE+1,:,:)**(1.0_PRC-GAMMA2)
        END WHERE
     ELSE
        WHERE (SDTYPE == 1) ! MRN
           NORMFAC = 3.0_PRC-GAMMA2
           NORMFAC = PI * &
                ((APTS(NSIZE+1,:,:)**NORMFAC)-(APTS(0,:,:)**NORMFAC))/&
                NORMFAC
        ELSEWHERE ! KMH
           NORMFAC = SUM(AWTS * &
                ((-LOG(APTS(1:NSIZE,:,:)))**&
                SPREAD(2.0_PRC-GAMMA2,1,NSIZE)),1)
           NORMFAC = PI * NORMFAC * APTS(NSIZE+1,:,:)**(3.0_PRC-GAMMA2)
        END WHERE
     END IF
!!$---------------------------------------------------------------------
!!$  Calculate size & composition averaged single grain mass.
!!$---------------------------------------------------------------------
!!$    Calculate size averaged single grain mass (GMASS(GTYPE,ZONE)) by
!!$
!!$                AMAX/Infinity
!!$                     |           4 PI  3     
!!$                      |   RHOGR  ---- a  n(a) da
!!$                       |          3
!!$                     AMIN
!!$        GMASS   =  --------------------------- 
!!$                                 
!!$                             NORMFAC  
!!$                                 
!!$    in which the upper bound depends on the size distribution.    
!!$
!!$    In Harrington's formulation,
!!$
!!$                4 PI      3
!!$        GMASS = ---- GSIZE  RHOGR
!!$                 3 
!!$
!!$    where GSIZE is size averaged grain size defined by
!!$
!!$                AMAX/Infinity
!!$                     |           2      
!!$                      |   a  PI a  n(a) da
!!$                       |        
!!$                     AMIN
!!$        GSIZE   =  --------------------------- 
!!$                 AMAX/Infinity
!!$                      |         2      
!!$                       |    PI a  n(a) da
!!$                        |        
!!$                      AMIN
!!$
!!$    GMASS is in g (GSIZE in cm).  Then, size & composition averaged 
!!$    single grain mass (AVGMASS(GTYPE,ZONE)) is
!!$
!!$                      NG
!!$       AVGMASS(NZ)  =  E   NUMWT(i,ZONE) * GMASS(i,ZONE)
!!$                      i=1
!!$
!!$    Prior to this step at the end of this section, the number percent 
!!$    weights (NUMWT(GTYPE,ZONE)) have to be calculated from the mass 
!!$    percent weights (MASSWT(GTYPE,ZONE)).
!!$---------------------------------------------------------------------
     ALLOCATE(GMASS(MXTY,NZONE),STAT=IERROR)
     GMASS = 1.0_PRC
     IF (NFLAG /= 0) THEN
        ALLOCATE(GSIZE(MXTY,NZONE),STAT=IERROR)
        GSIZE = 0.0_PRC
     END IF
!!$---------------------------------------------------------------------
     FAC = FOURPI/3.0_PRC 
     IF (NFLAG == 0) THEN
        WHERE (SDTYPE == 1) 
           GMASS = 4.0_PRC - GAMMA2 ! = (4 - gamma)
           GMASS = FAC*RHOGR/NORMFAC * &
                (APTS(NSIZE+1,:,:)**GMASS-APTS(0,:,:)**GMASS)/GMASS
        ELSEWHERE
           GMASS = SUM(AWTS * &
                ((-LOG(APTS(1:NSIZE,:,:)))**SPREAD(3.0_PRC-GAMMA2,1,NSIZE)),1)
           GMASS = GMASS*FAC*RHOGR/NORMFAC * &
                APTS(NSIZE+1,:,:)**(4.0_PRC-GAMMA2)
        END WHERE
     ELSE
        WHERE (SDTYPE == 1) 
           GSIZE = 4.0_PRC - GAMMA2 ! = (4 - gamma)
           GSIZE = PI/NORMFAC * &
                (APTS(NSIZE+1,:,:)**GSIZE-APTS(0,:,:)**GSIZE)/GSIZE
        ELSEWHERE
           GSIZE = SUM(AWTS * &
                ((-LOG(APTS(1:NSIZE,:,:)))**SPREAD(3.0_PRC-GAMMA2,1,NSIZE)),1)
           GSIZE = GSIZE*PI/NORMFAC * &
                APTS(NSIZE+1,:,:)**(4.0_PRC-GAMMA2)
        END WHERE
        GMASS = FAC*GSIZE*GSIZE*GSIZE*RHOGR
     END IF
     DEALLOCATE(NORMFAC,STAT=IERROR)
    IF (NFLAG /= 0) DEALLOCATE(GSIZE,STAT=IERROR)
!!$---------------------------------------------------------------------
!!$  Solve for number weights (NUMWT) using input mass weights (MASSWT)
!!$  and compute size and composition averaged grain mass AVGMASS(NZONE)
!!$---------------------------------------------------------------------
!!$  Since we know the (size) averaged grain mass of each species by 
!!$  now, we can solve for number weights for each species explicitly.
!!$
!!$  Weights are in percent and AVGMASS(NZ) is in g
!!$---------------------------------------------------------------------
!!$    The NZONE loop is needed to set values in unused NUMWT slots 0 
!!$---------------------------------------------------------------------
     DO NZ=1,NZONE
        AVGMASS(NZ) = &
             SUM(MASSWT(1:NGTYPE(NZ),NZ)/GMASS(1:NGTYPE(NZ),NZ),1)
        NUMWT(1:NGTYPE(NZ),NZ) = MASSWT(1:NGTYPE(NZ),NZ)/ &
             GMASS(1:NGTYPE(NZ),NZ)/AVGMASS(NZ)
        IF ((NFLAG == 0).or.(NFLAG == 1)) THEN
           AVGMASS(NZ) = &
                SUM(NUMWT(1:NGTYPE(NZ),NZ)*GMASS(1:NGTYPE(NZ),NZ),1)
        ELSE
           AVGMASS(NZ) = PRODUCT(GMASS(1:NGTYPE(NZ),NZ)** &
                NUMWT(1:NGTYPE(NZ),NZ),1)
        END IF
     END DO
!!$---------------------------------------------------------------------
!!$  Output dust parameters obtained so far if interactive mode is on
!!$---------------------------------------------------------------------
     IF (IOFLAG == 0) THEN 
        DO NZ=1,NZONE
           WRITE(*,'(" Grain Properties Chart (Units in CGS)")')
           WRITE(*,'("  Layer # ",I2)') NZ 
           WRITE(*,'("    Dust Grains   ")')
           DO NG=1,NGTYPE(NZ)
              WRITE(*,'(5X,"Species # ",i2,":",2X,A)') NG,NKFILE(NG,NZ)
           END DO
           WRITE(*,'("    Physical Parameters   ")')
           WRITE(*,'("     SD    MassWT      NumWT    GrainMass   &
                &Density     a_min    a_max/a_0")')
           DO NG=1,NGTYPE(NZ)
              IF (SDTYPE(NG,NZ) == 1) THEN
                 DUMMY = 'MRN'
              ELSE 
                 DUMMY = 'KMH'
              END IF
              WRITE(*,'(5X,A3,6(ES11.3))') DUMMY,MASSWT(NG,NZ), &
                   &NUMWT(NG,NZ),GMASS(NG,NZ),RHOGR(NG,NZ),      &
                   &AMIN(NG,NZ)*1.0E-04_PRC,AMAX(NG,NZ)*1.0E-04_PRC
           END DO
           WRITE(*,'("    Size & composition averaged grain mass: ",&
                &ES11.3," g")') AVGMASS(NZ)
           WRITE(*,'("  ")') 
        END DO
     END IF
     DEALLOCATE(MASSWT,STAT=IERROR)
!!$---------------------------------------------------------------------
!!$  Finally, compute cross sections (KAPPA, SIGMA)
!!$---------------------------------------------------------------------
!!$    Calculate cross sections for each layer by
!!$
!!$                                  AMAX/Infinity
!!$                                     |              2   
!!$                                      |  Q(a,i) PI a  n(a) da
!!$                                       |
!!$               NG                     AMIN
!!$     KAP,SIG =  E  NUMWT(i,ZONE) * --------------------------------
!!$               i=1  
!!$                                             NORMFAC(i,ZONE)
!!$
!!$    in which the upper bound depends on the size distribution.    
!!$    In this case, KAP & SIG have units of cm^2.
!!$
!!$    In Harrington's formulation,
!!$
!!$                                  AMAX/Infinity
!!$                                     |              2   
!!$                                      |  Q(a,i) PI a  n(a) da
!!$                                       |
!!$                NG                     AMIN
!!$     avg of Q =  E  NUMWT(i,ZONE) * --------------------------------
!!$                i=1  
!!$                                             NORMFAC(i,ZONE)
!!$
!!$    NOTE: In the top definition, averaged cross sections are 
!!$          calculated, but in the bottom definition, averaged
!!$          Q values are calculated.  So, to get averaged cross
!!$          sections from the bottom definition, we need to multiply
!!$          the averaged Q values by PI GSIZE^2.
!!$
!!$    Q(a,i) refers to Q values (Qext, albedo, and G) for species i
!!$    and radius a at the specific wavelength.  Integration points
!!$    in size space will be determined by the Gauss-Legendre Quadrature
!!$    and the corresponding Q values will be obtained by calling MIE
!!$    subroutine.
!!$---------------------------------------------------------------------
!!$  Read n & k files
!!$---------------------------------------------------------------------
!!$    Determine the max # of lines in n & k files
!!$---------------------------------------------------------------------
     ALLOCATE(NNK(MXTY,NZONE),STAT=IERROR)
     ALLOCATE(NPAH(NZONE),    STAT=IERROR)
!!$---------------------------------------------------------------------
     NNK = 0
     NPAH = 0
     DO NZ = 1,NZONE
        DO NG = 1,NGTYPE(NZ)
           IF (TRIM(NKFILE(NG,NZ))/='PAH') THEN
              OPEN(UNIT=2,file=NKFILE(NG,NZ),iostat=ierror)
              IF (ierror /= 0) THEN
                 WRITE(*,'(" Error opening the n & k file: ",A)') &
                      &TRIM(NKFILE(NG,NZ))
                 STOP
              ELSE
                 I=0 ! initialize nk value counter
                 readloop: DO
                    READ(2,*,iostat=ierror) RDUM,RDUM,RDUM
                    IF (ierror /= 0) exit readloop
                    I = I + 1
                 END DO readloop
                 CLOSE(2)           
                 NNK(NG,NZ) = I
              END IF
           ELSE
              NPAH(NZ) = NG
           END IF
        END DO
     END DO
     MXNK = MAXVAL(NNK)
!!$---------------------------------------------------------------------
!!$  Interpolate n & k for the wavelengths specified in "SPECGRID" file
!!$---------------------------------------------------------------------
!!$       LAMBDA(i)          : wavelengths
!!$       N1()        : second derivatives needed in spline fitting
!!$       K1()        : second derivatives needed in spline fitting
!!$       N2(WAV,GTYPE,ZONE) : interpolated n's
!!$       K2(WAV,GTYPE,ZONE) : interpolated k's
!!$---------------------------------------------------------------------
     ALLOCATE(LAMIN(MXNK),        STAT=IERROR)
     ALLOCATE(NIN(MXNK),          STAT=IERROR)
     ALLOCATE(KIN(MXNK),          STAT=IERROR)
     ALLOCATE(N1(MXNK),           STAT=IERROR)
     ALLOCATE(K1(MXNK),           STAT=IERROR)
     ALLOCATE(N2(NWAV,MXTY,NZONE),STAT=IERROR)
     ALLOCATE(K2(NWAV,MXTY,NZONE),STAT=IERROR)
!!$---------------------------------------------------------------------
     N2 = 0.0_PRC
     K2 = 0.0_PRC
!!$---------------------------------------------------------------------
     RDUM = 1.0E+30_PRC
     DO NZ = 1,NZONE
        DO NG = 1,NGTYPE(NZ)
           NPTS = NNK(NG,NZ)
           IF (TRIM(NKFILE(NG,NZ))/='PAH') THEN
              OPEN(UNIT=2,FILE=NKFILE(NG,NZ),iostat=ierror)
              DO N=1,NPTS
                 READ(2,*) LAMIN(N),NIN(N),KIN(N)
              END DO
              IF ((LAMBDA(1)<LAMIN(1)).OR.(LAMBDA(NWAV)>LAMIN(NPTS))&
                   .AND.(IOFLAG==0))&
                   THEN
                 WRITE(*,'(" Warning: Short n & k file - ",A)') &
                      &NKFILE(NG,NZ)(1:LEN_TRIM(NKFILE(NG,NZ)))
                 WRITE(*,'("          This n&k file does not cover&
                      & the whole spectral range, and")')
                 WRITE(*,'("          therefore, cross sections are&
                      & spline extrapolated.")')
              END IF
              CLOSE(2)
              CALL SPLINE(LAMIN,NIN,NPTS,RDUM,RDUM,N1)
              CALL SPLINE(LAMIN,KIN,NPTS,RDUM,RDUM,K1)
              DO NW=1,NWAV
                 CALL SPLINT(LAMIN,NIN,N1,NPTS,LAMBDA(NW),N2(NW,NG,NZ))
                 CALL SPLINT(LAMIN,KIN,K1,NPTS,LAMBDA(NW),K2(NW,NG,NZ))
              END DO
           END IF
        END DO
     END DO
!!$---------------------------------------------------------------------
     DEALLOCATE(LAMIN,NIN,KIN,N1,K1,NKFILE,NNK,STAT=IERROR)
!!$---------------------------------------------------------------------
!!$  Repeat the process to interpolate n & k for PAH (2 kinds of AC)
!!$---------------------------------------------------------------------
!!$       LAMBDA(i)          : wavelengths
!!$       N1()        : second derivatives needed in spline fitting
!!$       K1()        : second derivatives needed in spline fitting
!!$       N2C(WAV,2,ZONE) : interpolated n's
!!$       K2C(WAV,2,ZONE) : interpolated k's
!!$---------------------------------------------------------------------
     IF (SUM(NPAH)>0) THEN
!!$---------------------------------------------------------------------
        ALLOCATE(NNK(2,1),   STAT=IERROR)
        ALLOCATE(N2C(NWAV,2,NZONE),STAT=IERROR)
        ALLOCATE(K2C(NWAV,2,NZONE),STAT=IERROR)
!!$---------------------------------------------------------------------
        N2C = 0.0_PRC
        K2C = 0.0_PRC
!!$---------------------------------------------------------------------
!!$  Read in graphite N&K values file
!!$---------------------------------------------------------------------
        NNK = 0
        DO NG=1,2
           OPEN(UNIT=2,file=NKFILEC(NG),iostat=ierror)
           IF (ierror /= 0) THEN
              WRITE(*,'(" Error opening the n & k file: ",A)') &
                   NKFILEC(NG)
              STOP
           ELSE
              I=0 ! initialize nk value counter
              readloop2: DO
                 READ(2,*,iostat=ierror) RDUM,RDUM,RDUM
                 IF (ierror /= 0) exit readloop2
                 I = I + 1
              END DO readloop2
              CLOSE(2)           
              NNK(NG,1) = I ! number of lines in graphite n&k
           END IF
        END DO
        MXNK = MAXVAL(NNK)
!!$---------------------------------------------------------------------
!!$  Set up temporary arrays
!!$---------------------------------------------------------------------
        ALLOCATE(LAMIN(MXNK),STAT=IERROR)
        ALLOCATE(NIN(MXNK),  STAT=IERROR)
        ALLOCATE(KIN(MXNK),  STAT=IERROR)
        ALLOCATE(N1(MXNK),   STAT=IERROR)
        ALLOCATE(K1(MXNK),   STAT=IERROR)
!!$---------------------------------------------------------------------
!!$  Get N & K values for the givem LAM
!!$---------------------------------------------------------------------
        RDUM = 1.0E+30_PRC
        DO NZ = 1,NZONE
           IF (NPAH(NZ)>0) THEN
              DO NG = 1,2
                 NPTS = NNK(NG,NZ)
                 OPEN(UNIT=2,FILE=NKFILEC(NG),iostat=ierror)
                 DO N=1,NPTS
                    READ(2,*) LAMIN(N),NIN(N),KIN(N)
                 END DO
                 IF ((LAMBDA(1)<LAMIN(1)).OR.(LAMBDA(NWAV)>LAMIN(NPTS))&
                      .AND.(IOFLAG==0))&
                      THEN
                    WRITE(*,'(" Warning: Short n & k file - ",A)') &
                         &NKFILE(NG,NZ)(1:LEN_TRIM(NKFILE(NG,NZ)))
                    WRITE(*,'("          This n&k file does not cover&
                         & the whole spectral range, and")')
                    WRITE(*,'("          therefore, cross sections are&
                         & spline extrapolated.")')
                 END IF
                 CLOSE(2)
                 CALL SPLINE(LAMIN,NIN,NPTS,RDUM,RDUM,N1)
                 CALL SPLINE(LAMIN,KIN,NPTS,RDUM,RDUM,K1)
                 DO NW=1,NWAV
                    CALL SPLINT(LAMIN,NIN,N1,NPTS,LAMBDA(NW),N2C(NW,NG,NZ))
                    CALL SPLINT(LAMIN,KIN,K1,NPTS,LAMBDA(NW),K2C(NW,NG,NZ))
                 END DO
              END DO
           END IF
        END DO
!!$---------------------------------------------------------------------
        DEALLOCATE(LAMIN,NIN,KIN,N1,K1,NNK,STAT=IERROR)
!!$---------------------------------------------------------------------
     END IF
!!$---------------------------------------------------------------------
!!$  Compute Q values
!!$---------------------------------------------------------------------
     ALLOCATE(QABS(NWAV,NSIZE,MXTY,NZONE),STAT=IERROR)
     ALLOCATE(QSCA(NWAV,NSIZE,MXTY,NZONE),STAT=IERROR)
     ALLOCATE(GEEE(NWAV,NSIZE,MXTY,NZONE),STAT=IERROR)
     QABS = 0.0_PRC
     QSCA = 0.0_PRC
     GEEE = 0.0_PRC
!!$---------------------------------------------------------------------
!!$  Begin integration over size space 
!!$---------------------------------------------------------------------
     BETA = 1 ! spherical grains
!!$---------------------------------------------------------------------
     IF (IOFLAG == 0) THEN
        WRITE(*,'(" Computing cross sections for each layer... ")')
     END IF
     DO NW=1,NWAV
        DO NZ=1,NZONE
           DO NG=1,NGTYPE(NZ)
!!$              IF (IOFLAG == 0) THEN
!!$                 WRITE(*,'(2X,"Wavelength: ",i3,"/",i3,&
!!$                      &" ZONE: ",i3,"/",i3,&
!!$                      &" Grain: ",i3,"/",i3)') &
!!$                      NW,NWAV,NZ,NZONE,NG,NGTYPE(NZ)
!!$              END IF
              GAM1 = - GAMMA2(NG,NZ) ! = -gamma
              GAM  = 2.0_PRC + GAM1  ! = (2 - gamma)
              SELECT CASE(SDTYPE(NG,NZ))
              CASE (1) ! MRH case
                 SUM1 = 0.0_PRC
                 SUM2 = 0.0_PRC
                 SUM3 = 0.0_PRC
                 IF (NW == 1) THEN
                    CALL GAULEG(AMIN(NG,NZ),AMAX(NG,NZ),PTS1,WTS1,NSIZE)
                    ! Subroutine MIE needs radii in microns, and so, 
                    ! PTS1 and WTS1 are in microns here
                 END IF
                 DO N=1,NSIZE
                    IF (NPAH(NZ)/=NG) THEN ! non-PAH case (default)
                       CALL MIE(N2(NW,NG,NZ),K2(NW,NG,NZ),LAMBDA(NW),&
                            PTS1(N),BETA,QE,QS,QA,GE)
                    ELSE ! PAH case
                       CALL PAH(LAMBDA(NW),PTS1(N),N2C(NW,:,NZ),&
                            K2C(NW,:,NZ),beta,QE,QS,QA,GE)
                    END IF
                    ! Here, QE, QS, QA, GE are dimensionless
                    ! But, PTS1 and WTS1 are in microns
                    PTSCM = PTS1(N)*1.0E-04_PRC ! from um to cm
                    WTSCM = WTS1(N)*1.0E-04_PRC ! from um to cm
                    APTS(N,NG,NZ) = PTSCM 
                    AWTS(N,NG,NZ) = WTSCM                    
                    QABS(NW,N,NG,NZ) = QA
                    QSCA(NW,N,NG,NZ) = QS
                    GEEE(NW,N,NG,NZ) = GE
                 END DO
              CASE (2) ! KMH case
                 SUM1 = 0.0_PRC
                 SUM2 = 0.0_PRC
                 SUM3 = 0.0_PRC
                 IF (NW == 1) THEN
                    RDUM = EXP(-1.0_PRC * AMIN(NG,NZ)/AMAX(NG,NZ))
                    CALL GAULEG(0.0_PRC,RDUM,PTS1,WTS1,NSIZE)
                 END IF
                 DO N=1,NSIZE
                    CALL MIE(N2(NW,NG,NZ),K2(NW,NG,NZ),LAMBDA(NW),&
                         -1.0_PRC*AMAX(NG,NZ)*LOG(PTS1(N)),BETA,&
                         QE,QS,QA,GE)
                    ! QS, QA, GE, PTS1, WTS1 are dimensionless
                    PTSCM = PTS1(N)
                    WTSCM = WTS1(N)
                    APTS(N,NG,NZ) = PTSCM 
                    AWTS(N,NG,NZ) = WTSCM   
                    QABS(NW,N,NG,NZ) = QA
                    QSCA(NW,N,NG,NZ) = QS
                    GEEE(NW,N,NG,NZ) = GE
                 END DO
              END SELECT
           END DO
        END DO
     END DO
     DEALLOCATE(WTS1,PTS1,N2,K2,AMIN,AMAX,STAT=IERROR)
!!$---------------------------------------------------------------------
!!$  Obtain mean cross sections:
!!$---------------------------------------------------------------------
!!$    OLD way - 
!!$      size-average: surface area weighted mean
!!$      composition:  weighted arithmetic mean
!!$    NEW way -
!!$      size-average: surface area weighted mean
!!$      composition:  weighted geometric mean (be consistent with the
!!$                    treatment of Planck function with multiple T's)
!!$---------------------------------------------------------------------
     ALLOCATE(DUMARR1(NSIZE,MXTY,NZONE),STAT=ierror)
     ALLOCATE(DUMARR2(NSIZE,MXTY,NZONE),STAT=ierror)
     ALLOCATE(DUMARR3(MXTY,NZONE),      STAT=ierror)
     ALLOCATE(DUMARR4(MXTY,NZONE),      STAT=ierror)
     ALLOCATE(DUMARR5(MXTY,NZONE),      STAT=ierror)
     ALLOCATE(DUMARR6(MXTY,NZONE),      STAT=ierror)
     ALLOCATE(KAPEXP(NWAV,MXTY,NZONE),  STAT=ierror)
     ALLOCATE(SIGEXP(NWAV,MXTY,NZONE),  STAT=ierror)
     ALLOCATE(GEEEXP(NWAV,MXTY,NZONE),  STAT=ierror)
!!$---------------------------------------------------------------------
     DUMARR1 = 0.0_PRC
     DUMARR2 = 0.0_PRC
     DUMARR3 = 0.0_PRC
     DUMARR4 = 0.0_PRC
     DUMARR5 = 0.0_PRC
     DUMARR6 = 0.0_PRC
     KAPEXP  = 0.0_PRC
     SIGEXP  = 0.0_PRC
     GEEEXP  = 0.0_PRC
!!$---------------------------------------------------------------------
!!$  Define DUMARR2 and DUMARR3 for size/composition space integration
!!$---------------------------------------------------------------------
!!$    DUMARR2: weights for size-space integration, n(a)da
!!$    DUMARR3: size-space integrated DUMARR2 (normalization factor) 
!!$
!!$    There are two things to consider here
!!$      1) size distribution type
!!$      2) averaging (mean taking) method
!!$
!!$    DUMARR2 is different only for size distribution type.
!!$    DUMARR3 is different for both size distribution and averaging 
!!$---------------------------------------------------------------------
     GAMMA2 = -1.0_PRC * GAMMA2 ! make it negative
     WHERE (SPREAD(SDTYPE,1,NSIZE) == 1) ! MRN
        DUMARR2 = AWTS * &
             (APTS(1:NSIZE,:,:)**SPREAD(2.0_PRC+GAMMA2,1,NSIZE))
        DUMARR1 = AWTS * &
             (APTS(1:NSIZE,:,:)**SPREAD(GAMMA2,1,NSIZE))
     ELSEWHERE ! KMH
        DUMARR2 = AWTS * &
             ((-LOG(APTS(1:NSIZE,:,:)))**SPREAD(2.0_PRC+GAMMA2,1,NSIZE))
        DUMARR1 = AWTS * &
             ((-LOG(APTS(1:NSIZE,:,:)))**SPREAD(GAMMA2,1,NSIZE))
     END WHERE
     IF ((NFLAG == 0).or.(NFLAG == 2)) THEN
        WHERE (SDTYPE == 1) ! MRN
           DUMARR3 = 1.0_PRC+GAMMA2
           DUMARR3 = &
                ((APTS(NSIZE+1,:,:)**DUMARR3)-(APTS(0,:,:)**DUMARR3))/&
                DUMARR3
        ELSEWHERE ! KMH
           DUMARR3 = SUM(AWTS * &
                ((-LOG(APTS(1:NSIZE,:,:)))**SPREAD(GAMMA2,1,NSIZE)),1)
           DUMARR3 = DUMARR3 * APTS(NSIZE+1,:,:)**(1.0_PRC+GAMMA2)
        END WHERE
     ELSE
        WHERE (SDTYPE == 1) ! MRN
           DUMARR3 = 3.0_PRC+GAMMA2
           DUMARR3 = &
                ((APTS(NSIZE+1,:,:)**DUMARR3)-(APTS(0,:,:)**DUMARR3))/&
                DUMARR3
        ELSEWHERE ! KMH
           DUMARR3 = SUM(AWTS * &
                ((-LOG(APTS(1:NSIZE,:,:)))**&
                SPREAD(2.0_PRC+GAMMA2,1,NSIZE)),1)
           DUMARR3 = DUMARR3 * APTS(NSIZE+1,:,:)**(3.0_PRC+GAMMA2)
        END WHERE
     END IF
!!$---------------------------------------------------------------------
!!$  Get KAPPA, SIGMA, & ASYMP
!!$---------------------------------------------------------------------
!!$    For the asymptotic parameter, averaging method is always 
!!$    weighted arithmetic mean (-1 =< g =< 1).
!!$---------------------------------------------------------------------
     DO NW=1,NWAV
        SELECT CASE(NFLAG)
!!$---------------------------------------------------------------------
!!$     CASE(0): default avg, weighted arithmetic mean
!!$---------------------------------------------------------------------
        CASE(0)
           WHERE (SDTYPE == 1) ! MRN
              DUMARR4 = NUMWT*SUM(Qabs(NW,:,:,:)*DUMARR2,1)/DUMARR3
              DUMARR5 = NUMWT*SUM(Qsca(NW,:,:,:)*DUMARR2,1)/DUMARR3
              DUMARR6 = NUMWT*SUM(GEEE(NW,:,:,:)*DUMARR1,1)/DUMARR3
           ELSEWHERE ! KMH
              DUMARR4 = NUMWT*(APTS(NSIZE+1,:,:)**(3.0_PRC+GAMMA2))*&
                   SUM(Qabs(NW,:,:,:)*DUMARR2,1)/DUMARR3
              DUMARR5 = NUMWT*(APTS(NSIZE+1,:,:)**(3.0_PRC+GAMMA2))*&
                   SUM(Qsca(NW,:,:,:)*DUMARR2,1)/DUMARR3
              DUMARR6 = NUMWT*(APTS(NSIZE+1,:,:)**(1.0_PRC+GAMMA2))*&
                   SUM(GEEE(NW,:,:,:)*DUMARR1,1)/DUMARR3
           END WHERE
           KAPPA(NW,:) = PI*SUM(DUMARR4,1)
           SIGMA(NW,:) = PI*SUM(DUMARR5,1)
           ASYMP(NW,:) = SUM(DUMARR6,1)
!!$---------------------------------------------------------------------
!!$     CASE(2): default avg, weighted geometric mean
!!$---------------------------------------------------------------------
        CASE(2)
           WHERE (SDTYPE == 1) ! MRN
              DUMARR4 = (SUM(Qabs(NW,:,:,:)*DUMARR2,1)/DUMARR3)**NUMWT
              DUMARR5 = (SUM(Qsca(NW,:,:,:)*DUMARR2,1)/DUMARR3)**NUMWT
              DUMARR6 = (SUM(GEEE(NW,:,:,:)*DUMARR2,1)/DUMARR3)*NUMWT
           ELSEWHERE ! KMH
              DUMARR4 = ((APTS(NSIZE+1,:,:)**(3.0_PRC+GAMMA2))*&
                   SUM(Qabs(NW,:,:,:)*DUMARR2,1)/DUMARR3)**NUMWT
              DUMARR5 = ((APTS(NSIZE+1,:,:)**(3.0_PRC+GAMMA2))*&
                   SUM(Qsca(NW,:,:,:)*DUMARR2,1)/DUMARR3)**NUMWT
              DUMARR6 = ((APTS(NSIZE+1,:,:)**(1.0_PRC+GAMMA2))*&
                   SUM(GEEE(NW,:,:,:)*DUMARR2,1)/DUMARR3)*NUMWT
           END WHERE
           KAPPA(NW,:) = PI*PRODUCT(DUMARR4,1)
           SIGMA(NW,:) = PI*PRODUCT(DUMARR5,1)
           ASYMP(NW,:) = SUM(DUMARR6,1)
!!$---------------------------------------------------------------------
!!$     CASE(1): Harrington avg, weighted arithmetic mean
!!$---------------------------------------------------------------------
        CASE(1)
           WHERE (SDTYPE == 1) ! MRN
              DUMARR4 = NUMWT*SUM(Qabs(NW,:,:,:)*DUMARR2,1)/DUMARR3
              DUMARR5 = NUMWT*SUM(Qsca(NW,:,:,:)*DUMARR2,1)/DUMARR3
              DUMARR6 = NUMWT*SUM(GEEE(NW,:,:,:)*DUMARR2,1)/DUMARR3
           ELSEWHERE ! KMH
              DUMARR4 = NUMWT*(APTS(NSIZE+1,:,:)**(3.0_PRC+GAMMA2))*&
                   SUM(Qabs(NW,:,:,:)*DUMARR2,1)/DUMARR3
              DUMARR5 = NUMWT*(APTS(NSIZE+1,:,:)**(3.0_PRC+GAMMA2))*&
                   SUM(Qsca(NW,:,:,:)*DUMARR2,1)/DUMARR3
              DUMARR6 = NUMWT*(APTS(NSIZE+1,:,:)**(3.0_PRC+GAMMA2))*&
                   SUM(GEEE(NW,:,:,:)*DUMARR2,1)/DUMARR3
           END WHERE
!!$---------------------------------------------------------------------
!!$        SUM(DUMARR4) and SUM(DUMARR5) are <Qabs> and <Qsca>
!!$---------------------------------------------------------------------
           KAPPA(NW,:) = PI*SUM(DUMARR4,1)
           SIGMA(NW,:) = PI*SUM(DUMARR5,1)
           ASYMP(NW,:) = SUM(DUMARR6,1)
           WHERE (SDTYPE == 1) ! MRN
              DUMARR4 = 4.0_PRC+GAMMA2
              DUMARR4 = NUMWT*((APTS(NSIZE+1,:,:)**DUMARR4)-&
                   (APTS(0,:,:)**DUMARR4))/DUMARR4/DUMARR3
           ELSEWHERE ! KMH
              DUMARR4 = SUM(AWTS * &
                   ((-LOG(APTS(1:NSIZE,:,:)))**&
                   SPREAD(3.0_PRC+GAMMA2,1,NSIZE)),1)
              DUMARR4 = NUMWT * DUMARR4 * &
                   (APTS(NSIZE+1,:,:)**(4.0_PRC+GAMMA2)) / DUMARR3
           END WHERE
!!$---------------------------------------------------------------------
!!$        SUM(DUMARR4) is <a>
!!$---------------------------------------------------------------------
           KAPPA(NW,:) = KAPPA(NW,:)*(SUM(DUMARR4,1)**2.0_PRC)
           SIGMA(NW,:) = SIGMA(NW,:)*(SUM(DUMARR4,1)**2.0_PRC)
!!$---------------------------------------------------------------------
!!$     CASE(3): Harrington avg, weighted geometric mean
!!$---------------------------------------------------------------------
        CASE(3)
           WHERE (SDTYPE == 1) ! MRN
              DUMARR4 = (SUM(Qabs(NW,:,:,:)*DUMARR2,1)/DUMARR3)
              DUMARR5 = (SUM(Qsca(NW,:,:,:)*DUMARR2,1)/DUMARR3)
              DUMARR6 = (SUM(GEEE(NW,:,:,:)*DUMARR2,1)/DUMARR3)
           ELSEWHERE ! KMH
              DUMARR4 = ((APTS(NSIZE+1,:,:)**(3.0_PRC+GAMMA2))*&
                   SUM(Qabs(NW,:,:,:)*DUMARR2,1)/DUMARR3)
              DUMARR5 = ((APTS(NSIZE+1,:,:)**(3.0_PRC+GAMMA2))*&
                   SUM(Qsca(NW,:,:,:)*DUMARR2,1)/DUMARR3)
              DUMARR6 = ((APTS(NSIZE+1,:,:)**(3.0_PRC+GAMMA2))*&
                   SUM(GEEE(NW,:,:,:)*DUMARR2,1)/DUMARR3)
           END WHERE
           KAPEXP(NW,:,:) = DUMARR4
           SIGEXP(NW,:,:) = DUMARR5
           GEEEXP(NW,:,:) = DUMARR6
!!$!!$------------------------------------------------------------------
!!$!!$     SUM(DUMARR4) and SUM(DUMARR5) are <Qabs> and <Qsca>
!!$!!$------------------------------------------------------------------
           KAPPA(NW,:) = PI*PRODUCT(DUMARR4**NUMWT,1) ! times PI
           SIGMA(NW,:) = PI*PRODUCT(DUMARR5**NUMWT,1) ! times PI
           ASYMP(NW,:) = SUM(DUMARR6*NUMWT,1)
           WHERE (SDTYPE == 1) ! MRN
              DUMARR4 = 4.0_PRC+GAMMA2
              DUMARR4 = (((APTS(NSIZE+1,:,:)**DUMARR4) - &
                   (APTS(0,:,:)**DUMARR4))/DUMARR4/DUMARR3)
           ELSEWHERE ! KMH
              DUMARR4 = SUM(AWTS * &
                   ((-LOG(APTS(1:NSIZE,:,:)))**&
                   SPREAD(3.0_PRC+GAMMA2,1,NSIZE)),1)
              DUMARR4 = (DUMARR4 * &
                   (APTS(NSIZE+1,:,:)**(4.0_PRC+GAMMA2))/DUMARR3)
           END WHERE
           KAPEXP(NW,:,:) = PI*(DUMARR4**2.0_PRC)*KAPEXP(NW,:,:)
           SIGEXP(NW,:,:) = PI*(DUMARR4**2.0_PRC)*SIGEXP(NW,:,:)
!!$!!$------------------------------------------------------------------
!!$!!$     SUM(DUMARR4) is <a>, below is "times a^2"
!!$!!$------------------------------------------------------------------
           KAPPA(NW,:)=KAPPA(NW,:)*(PRODUCT(DUMARR4**NUMWT,1)**2.0_PRC)
           SIGMA(NW,:)=SIGMA(NW,:)*(PRODUCT(DUMARR4**NUMWT,1)**2.0_PRC)
        END SELECT
     END DO
     DEALLOCATE(DUMARR1,DUMARR2,DUMARR3,STAT=IERROR)
     DEALLOCATE(DUMARR4,DUMARR5,DUMARR6,STAT=IERROR)
!!$---------------------------------------------------------------------
!!$  Output results to XSEC
!!$---------------------------------------------------------------------
     XLEN = LEN_TRIM(XSEC)
     WRITE(XSEC(XLEN+1:XLEN+4),'(".dat")')
     OPEN(UNIT=31,FILE=XSEC,STATUS='unknown',IOSTAT=IERROR)
     DO NZ=1,NZONE
        WRITE(31,19) AVGMASS(NZ)
        WRITE(*,19) AVGMASS(NZ)
        DO NW=1,NWAV
           WRITE(31,20) &
                &LAMBDA(NW),KAPPA(NW,NZ),SIGMA(NW,NZ),ASYMP(NW,NZ)
           WRITE(*,20) &
                &LAMBDA(NW),KAPPA(NW,NZ),SIGMA(NW,NZ),ASYMP(NW,NZ)
        END DO
     END DO
     CLOSE(UNIT=31)
!!$---------------------------------------------------------------------
!!$  Output results to SizeQ.dat for later use by QHEAT
!!$    For MRN, APTS are sizes in cm and Q are Q values
!!$    For KMN, APTS are "b" (= exp(-a/amax)) and Q are Q values;
!!$             both b and Q are dimensionless
!!$---------------------------------------------------------------------
     IF (NFLAG > 1) THEN
        OPEN(UNIT=31,FILE="SizeQ.dat",STATUS='unknown',IOSTAT=IERROR)
        DO NZ=1,NZONE
           DO NG=1,NGTYPE(NZ)
              WRITE(31,*) SDTYPE(NG,NZ),RHOGR(NG,NZ),NUMWT(NG,NZ), &
                   GAMMA2(NG,NZ)
              WRITE(31,*) APTS(0,NG,NZ)
              DO N=1,NSIZE
                 WRITE(31,*) APTS(N,NG,NZ),AWTS(N,NG,NZ)
                 WRITE(31,*) (QABS(NW,N,NG,NZ),NW=1,NWAV)
                 WRITE(31,*) (QSCA(NW,N,NG,NZ),NW=1,NWAV)
                 WRITE(31,*) (GEEE(NW,N,NG,NZ),NW=1,NWAV)
              END DO
              WRITE(31,*) APTS(NSIZE+1,NG,NZ)
           END DO
        END DO
        CLOSE(31)
     END IF
     IF (SUM(NPAH)>0) DEALLOCATE(N2C,K2C,STAT=IERROR)
     DEALLOCATE(APTS,AWTS,QABS,QSCA,GEEE,NPAH,STAT=IERROR)
     DEALLOCATE(SDTYPE,RHOGR,NUMWT,GAMMA2,GMASS,STAT=IERROR)
     IF (NFLAG > 1) THEN
        OPEN(UNIT=31,FILE="XsecEXP.dat",STATUS='unknown',IOSTAT=IERROR)
        DO NZ=1,NZONE
           DO NW=1,NWAV
              WRITE(31,*) (KAPEXP(NW,NG,NZ),NG=1,NGTYPE(NZ))
              WRITE(31,*) (SIGEXP(NW,NG,NZ),NG=1,NGTYPE(NZ))
              WRITE(31,*) (GEEEXP(NW,NG,NZ),NG=1,NGTYPE(NZ))
           END DO
        END DO
        CLOSE(31)
     END IF
     DEALLOCATE(KAPEXP,SIGEXP,GEEEXP,STAT=IERROR)
  END IF
  IF ((OLDNFLAG==2).AND.(NFLAG==3)) NFLAG = 2
!!$---------------------------------------------------------------------
  IF (XFLAG == 1) THEN
     IF (IOFLAG == 0) THEN
        WRITE(*,'("  Proceed? [Y/N] >> ")',advance='no')
        READ(*,'(A)') CKFLG 
        IF (CKFLG == "n" .OR. CKFLG == "N") STOP
        WRITE(*,13)
     END IF
  END IF
!!$---------------------------------------------------------------------
10 FORMAT('  Input file: ', A)
11 FORMAT('   Correct? [Y/N] >> ')
12 FORMAT('  Name input file (',A,') >> ')
13 FORMAT('  ')
19 FORMAT(ES19.6)
20 FORMAT(F14.5,3ES19.6)
!!$---------------------------------------------------------------------
END SUBROUTINE DUSTPREP
!!$---------------------------------------------------------------------

!!$---------------------------------------------------------------------  
FUNCTION DFUNC(X,TH)
!!$---------------------------------------------------------------------  
  USE PRCSN
!!  USE CONST, ONLY : PI,PIO2
!!  USE DEFVARS, ONLY : A,B,C,D,E,RSW,RMIN,THCRIT
  USE DEFVARS, ONLY : A,B,C,D,E,RATIODEN,RMAX,RMIN,RSW 
  IMPLICIT NONE
  REAL(PRC), INTENT(IN) :: X,TH
  REAL(PRC) :: DFUNC
  REAL(DBL) :: RATIO1,RATIO2,RATIO3,RATIO4,RATIO5,SINTH,COSTH
  SINTH =  SIN (TH)
  COSTH =  COS (TH)
  RATIO1 = (X*SINTH)/RMIN
  RATIO2 = (X*SINTH)/RSW
  RATIO3 = RSW/RMIN
  RATIO4 = ((X*COSTH)**2)/(2*(C*(RATIO1**D))**2)
  RATIO5 = ((X*COSTH)**2)/(2*(C*(RATIO3**D)*(RATIO2**E))**2)
  IF ((X*SINTH) <= RSW) THEN
  DFUNC =((RATIO1)**(-A))*EXP(-RATIO4)
  ELSE
  DFUNC =((RATIO3)**(-A))*((RATIO2)**(-B))*EXP(-RATIO5)
  EndIF 
  RETURN
END FUNCTION DFUNC

!!$---------------------------------------------------------------------  
FUNCTION DFUNC(X,TH)
!!$---------------------------------------------------------------------  
  USE PRCSN
  USE CONST, ONLY : PI,PIO2
  USE DEFVARS, ONLY : A,B,C,D,E,RSW,RMIN,THCRIT
  IMPLICIT NONE
  REAL(PRC), INTENT(IN) :: X,TH
  REAL(PRC) :: DFUNC
  REAL(DBL) :: RATIO,RATIO1,COSTH,SINTH

  RATIO  = X/RSW
  RATIO1 = RMIN/RSW
  IF (TH < PIO2) THEN
     COSTH = COS(TH)
  ELSE IF (TH > PIO2) THEN
     COSTH = -COS(TH)
  ELSE
     COSTH = 0.0_DBL
  END IF
  SINTH = SIN(TH)

  DFUNC = (RMIN/X)**( B* &
       (1.0+C*(SINTH**THCRIT)* EXP((RATIO1**D)-(RATIO**D))) ) * &
       (1.0+A*((1.0-COSTH)**THCRIT)* EXP((RATIO1**E)-(RATIO**E)))

  RETURN
END FUNCTION DFUNC

!!$---------------------------------------------------------------------  
FUNCTION DFUNC(X,TH)
!!$---------------------------------------------------------------------  
  USE PRCSN
  USE DEFVARS, ONLY : A,B,C,D,E,RSW,RMIN,THCRIT,PI
  IMPLICIT NONE
  REAL(PRC), INTENT(IN) :: X,TH
  REAL(PRC) :: DFUNC
  REAL(PRC) :: RATIO0, RATIO1, RATIO2, RATIO4

  RATIO4 = (RMIN/X)**B
  RATIO0 = RSW**C
  RATIO1 = X**C
  RATIO2 = RMIN**C
  RATIO1 = RATIO2 - RATIO1
  RATIO0 = RATIO1 / RATIO0 
  IF (THCRIT  <= TH .AND. TH <= PI-THCRIT) THEN
     DFUNC = RATIO4 * (1.0_PRC + E * EXP(RATIO0)) * &
          (1.0_PRC + A * SIN(TH) * EXP(RATIO0))
     DFUNC = DFUNC / ((1.+E)*(1.+A))
  ELSE
     DFUNC = D * RATIO4
  END IF
  RETURN
END FUNCTION DFUNC

!!$---------------------------------------------------------------------
SUBROUTINE SPLINT(XA,YA,Y2A,N,X,Y)
!!$---------------------------------------------------------------------
!!$  Given the arrays xa(1:n) and ya(1:n) containing a tabulated function,
!!$  ya(i)=f(xa(i)), with x(1)<...<x(i)<...<x(n), and y2a(1:n), which is 
!!$  the output from spline, and a value x, this routine returns a cubic-
!!$  spline interpolated value y.
!!$   [Adapted from Numerical Recipes in Fortran, S3.3, p110]
!!$---------------------------------------------------------------------
  USE PRCSN
!!$
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: N
  REAL(PRC),INTENT(IN), DIMENSION(N) :: XA,YA,Y2A
  REAL(PRC), INTENT(IN) :: X
  REAL(PRC), INTENT(OUT) :: Y

  INTEGER :: k,khi,klo
  REAL(PRC) :: a,b,h

  KLO = 1
  KHI = N

  DO
     IF (KHI-KLO <= 1) EXIT
     K = (KHI+KLO)/2
     IF(XA(K) > X)THEN
        KHI = K
     ELSE
        KLO = K
     END IF
  END DO

  H=XA(KHI)-XA(KLO)
  IF (H == 0.0_PRC) THEN
     WRITE(*,'(" Bad XA input in splint.f90.  Quiting... ")')
     STOP
  END IF
  A = (XA(KHI)-X)/H
  B = (X-XA(KLO))/H
  Y = A*YA(KLO)+B*YA(KHI) &
       + ((A**3.0_PRC - A)*Y2A(KLO)+(B**3.0_PRC - B)*Y2A(KHI)) &
       * (H**2.0_PRC)/6.0_PRC
  RETURN
END SUBROUTINE SPLINT

!!$---------------------------------------------------------------------
SUBROUTINE SPLINE(X,Y,N,YP1,YPN,Y2)
!!$---------------------------------------------------------------------
!*$* NO CONSURRENTIZE
!!$---------------------------------------------------------------------
!!$  Given arrays x(1:n) and y(1:n) containing a tabulated function,
!!$  y(i)=f(x(i)), with x(1)<...<x(i)<...<x(n), and values yp1 and ypn
!!$  for the first derivative of the interpolating function at points 
!!$  1 and n respectively, this routine returns an array y2(1:n) which
!!$  contains the second derivatives of the interpolating function at
!!$  the tabulated points x(i).  If yp1 and/or ypn are equal to 1.0e+30
!!$  or larger the algorithm follws natural spline in which the second
!!$  derivative at the boundaries are set to zero.
!!$   [Adapted from Numerical Recipes in Fortran, S3.3, p109]
!!$---------------------------------------------------------------------
  USE PRCSN
!!$
  IMPLICIT NONE
  REAL(PRC), PARAMETER :: MAXVAL = 1.0E+30_PRC

  INTEGER, INTENT(IN) :: N
  REAL(PRC), INTENT(IN), DIMENSION(N) :: X,Y
  REAL(PRC), INTENT(IN) :: yp1,ypn
  REAL(PRC), INTENT(OUT), DIMENSION(N) :: y2

  INTEGER :: I,K
  REAL(PRC), DIMENSION(N) :: U
  REAL(PRC) :: SIG,P,QN,UN

!!$  do i=1,n
!!$     write(*,*) i,x(i),y(i)
!!$  end do
  IF (YP1 >= MAXVAL) THEN
     Y2(1)=0.0_PRC
     U(1)=0.0_PRC
  ELSE
     Y2(1)=-0.5_PRC
     U(1)=(3.0_PRC/(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)
  END IF
  DO I=2,N-1
     SIG   = (X(I)-X(I-1))/(X(I+1)-X(I-1))
     P     = SIG*Y2(I-1)+2.0_PRC
     Y2(I) = (SIG-1.0_PRC)/P
     U(I)  = (6.0_PRC*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1)) &
          / (X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
  END DO
  IF (YPN >= MAXVAL) THEN
     QN=0.0_PRC
     UN=0.0_PRC
  ELSE
     QN=0.5_PRC
     UN=(3.0_PRC/(X(N)-X(N-1)))*(YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))
  END IF
  Y2(N)=(UN-QN*U(N-1))/(QN*Y2(N-1)+1.0_PRC)
  DO K=N-1,1,-1
     Y2(K)=Y2(K)*Y2(K+1)+U(K)
  END DO
  RETURN
END SUBROUTINE SPLINE

!!$---------------------------------------------------------------------
program mapgrid
!!$---------------------------------------------------------------------
!!$  Reads output (user specified) from mapspec and transform polar
!!$  grid format of mapspec output into cartesian grid format of 
!!$  user specified size and pixel scale.
!!$---------------------------------------------------------------------
  USE CONST
  implicit none
!!$---------------------------------------------------------------------
  character     :: ckflg
  character(40) :: infile,outfile1,outfile2,dummy,dummy1,dummy2
  integer :: i,j,k,l,m,n,iflag,nl,ntmp
  integer :: ierr,nwav,nlam,nphi,nrad,imxsize,imysize,xpix,ypix,nlen,nout
  integer :: xpixmax,xpixmin,ypixmax,ypixmin,count1,count2
  integer :: num,kstart,lstart,xsearchbox,ysearchbox,maxnum,minnum
  real(prc) :: dum,xmax,xmin,ymax,ymin,xpixscale,ypixscale,p,q,factor
  real(prc) :: tmpds2,tmpval1,tmpval2,tmpds22,sum1,sum2,wgt,thwidth
  real(prc) :: pixarea,rval,pval,dum1,dum2,oldds2
  integer, allocatable, dimension(:)   :: numwav
  integer, allocatable, dimension(:,:) :: npts1,flag1
  real(prc), allocatable, dimension(:)   :: rad,phi,val1,val2,ds2,lam
  real(prc), allocatable, dimension(:,:) :: flux,tau,xx,yy,fluxpix, &
       taupix,imagebox1,imagebox2,area,totarea,imagebox3,imagebox4,pix
!!$ fitsio variables
  integer oim,status,blocksize,naxes(2)
  integer :: nr,nq,mxstep,dflag,sflag,bflag,n0,nzone,ierror
  real(prc) :: vspace,rstar,tstar,distance,velocity,a,b,c,d,e,f,tau0, &
       f1,f2,f3
  real(prc), allocatable, dimension(:) :: rlayer      
!!$---------------------------------------------------------------------
!!$  Read input file
!!$---------------------------------------------------------------------
  open(unit=13,file='getmap.dat',status='old',iostat=iflag)
  if (iflag == 0) then
     read(13,'(A30)') infile
     read(13,*) imxsize, imysize
     read(13,*) xpixscale, ypixscale
     read(13,*) factor
     pixarea    = xpixscale*ypixscale ! pixel area in arcsec^2
     xsearchbox = ANINT(imxsize*factor)
     ysearchbox = ANINT(imysize*factor)
     read(13,*) nout
     allocate(numwav(nout))
     do i=1,nout
        read(13,*) numwav(i)
     end do
     close(13)
     open(unit=10,file=infile,status='old',iostat=ierr)
     if (ierr /= 0) then
        write(*,'("  Error opening the file!  Try again! ")')
        stop
     end if
  else     
     write(*,'("  ")')
     write(*,'("      *** MAPGRID ***    ")')
     write(*,'("  ")')
     do
        write(*,'(" Enter the input map file name >> ")',advance='no')
        read(*,'(A30)') infile
        open(unit=10,file=infile,status='old',iostat=ierr)
        if (ierr == 0) exit
        write(*,'("  Error opening the file!  Try again! ")')
     end do
  end if
  if (iflag /= 0) write(*,'(" READING INPUT FILE...")')   
  read(10,*) dum
  read(10,*) nwav
  do i=1,nwav
     read(10,*) dum
     if (iflag /= 0) then
        write(*,'("  ",i2,": ",ES12.6," microns")') i,dum
     end if
  end do
  if (iflag /= 0) then
     do
!!$        write(*,'(" Output to .dat (y) or just .fits (N) => ")',advance='no')
!!$        read(*,'(A)') datflag
        write(*,'(" Select multiple wavelengths? ")')
        write(*,'("  (Y / n) >> ")',advance='no') 
        read(*,'(A)') ckflg
        if (CKFLG == ' ' .OR. CKFLG == "y" .OR. CKFLG == "Y") then
           do
              write(*,'(" How many wavelengths? ")')
              write(*,'("  (number) >> ")',advance='no') 
              read(*,*) ntmp
              if (0 < ntmp .AND. ntmp <= nwav) then
                 nout = ntmp
                 exit
              else
                 write(*,'(" Invalid choice!  Select the number &
                      &again. ")')
                 write(*,'("  ")')
              end if
           end do
           exit
        else if (CKFLG == "n" .OR. CKFLG == "N") then    
           nout = 1
           exit
        end if
     end do
     allocate(numwav(nout))
     do i=1,nout
        do 
           write(*,'(" Select a wavelength by the number ")')
           write(*,'("  (number) >> ")',advance='no')
           read(*,*) ntmp
           if (0 < ntmp .AND. ntmp <= nwav) then
              numwav(i) = ntmp
              exit
           else
              write(*,'(" Invalid choice!  Select the number again. ")')
              write(*,'("   ")')
           end if
        end do
     end do
  end if
  read(10,*) nrad,nphi
  close(10)
  allocate(lam(nout))
  allocate(rad(0:nrad))
  allocate(phi(nphi))
  allocate(flux(nrad,nphi))
  allocate(tau(nrad,nphi))
  allocate(xx(nrad,nphi))
  allocate(yy(nrad,nphi))
  allocate(area(nrad,nphi))
  thwidth = pi/nphi
!!$---------------------------------------------------------------------
!!$  Partially done reading input file
!!$---------------------------------------------------------------------

  OPEN(UNIT=30,FILE='datafiles.dat',STATUS='OLD',IOSTAT=IERROR)
  READ(30,*) IERROR
  READ(30,'(A)') dummy
  CLOSE(30)
  nlen=len_trim(dummy)
  WRITE(dummy(NLEN+1:NLEN+4),'(''.dat'')')
  nlen=len_trim(dummy)
  OPEN(UNIT=4,file=dummy,STATUS='old',IOSTAT=IERROR) 
  IF (IERROR /= 0) THEN
     WRITE(*,14) dummy(1:nlen)
     WRITE(*,'(" skipping header information")')
     GO TO 111
  END IF
 14    FORMAT(' Error: File ',A,' does not exist! Try again. ')
  READ(4,*) NR,NQ          
  READ(4,*) MXSTEP,VSPACE           
  READ(4,*) DFLAG,SFLAG,BFLAG
  READ(4,*) RSTAR,TSTAR      
  READ(4,*) DISTANCE         
  READ(4,*) VELOCITY         
  READ(4,*) A,B,C,D,E,F
  READ(4,*) TAU0,N0          
  READ(4,*) F1,F2,F3         
  READ(4,*) NZONE            
  ALLOCATE(RLAYER(0:NZONE), STAT=IERROR)
  IF (NZONE /= 1) THEN
     READ(4,*) (RLAYER(I),I=1,NZONE-1)
  ENDIF
  RLAYER(0)     = 1.0_PRC ! = Rmin
  RLAYER(NZONE) = F2      ! = Rmax
  CLOSE(UNIT=4,STATUS='keep')

 111  continue

!!$---------------------------------------------------------------------
!!$  Set output image size and pixel scales
!!$---------------------------------------------------------------------
     if (iflag /= 0) then
        write(*,'(" Enter output image SIZE in even integer pixels ")')
        write(*,'("  (xsize ysize) >> ")',advance='no') 
        read(*,*) imxsize, imysize
        write(*,'("  ")')
        write(*,'("   Output images will have ",i5," x ",i5," pixels.")') &
             imxsize,imysize
        write(*,'("  ")')
        write(*,'(" Enter output image PIXEL SCALE in arcsec/pix ")')
        write(*,'("  (xpixscale ypixscale) >> ")',advance='no')
        read(*,*) xpixscale, ypixscale
        write(*,'("  ")')
        write(*,'("   Output images will cover ",es10.4," x ",es10.4, &
             &" arcsec^2.")') imxsize*xpixscale,imysize*ypixscale
        write(*,'("  ")')
        pixarea = xpixscale*ypixscale ! pixel area in arcsec^2
     end if
!!$---------------------------------------------------------------------
!!$  Done setting output image size and pixel scales
!!$---------------------------------------------------------------------

!!$---------------------------------------------------------------------
!!$  Define a serach box
!!$---------------------------------------------------------------------
!!$      An "imagebox" has (xpixmin:xpixmax,ypixmin:ypixmax) pixels. 
!!$      Thus, the total number of pixels in the imagebox is AT MOST 
!!$      twice as many as the final image for interpolating purposes.
!!$---------------------------------------------------------------------
     if (iflag /= 0) then
        factor = 0.3_prc
        write(*,'(" Enter the search box size relative to final image ")')
        write(*,'("  (factor = 0.3 -> box is 30% of the image, max = 1) [",&
             &f6.4,"] >> ")',advance='no') factor
        read(*,'(A)') dummy
        if (dummy == ' ') then
           factor = factor
        else
           read(dummy,*) factor
           if (factor > 1.0_prc) factor = 1.0_prc
        end if
        xsearchbox = ANINT(imxsize*factor)
        ysearchbox = ANINT(imysize*factor)
        write(*,'("  ")')
        write(*,'("   Searchbox of [",i4,", ",i4,"] will be used.")') &
             xsearchbox,ysearchbox
        write(*,'("  ")')
     end if
!!$---------------------------------------------------------------------
!!$  Done defining a serach box
!!$---------------------------------------------------------------------

!!$---------------------------------------------------------------------
!!$  Repeat the following steps to generate the desired number of maps
!!$---------------------------------------------------------------------
  do nl=1,nout
     nlam = numwav(nl)
     rad  = 0.0_prc
     phi  = 0.0_prc
     flux = 0.0_prc
     tau  = 0.0_prc
     xx   = 0.0_prc
     yy   = 0.0_prc
     area = 0.0_prc
     open(unit=10,file=infile,status='old',iostat=ierr)
     do i=1,nwav+3
        read(10,'(A30)') dummy
     end do
     do i=1,nphi
        do j=1,nrad
           if (j /= 1) then
              read(10,*) rval,dum
              rad(j) = rval 
           else
              read(10,*) rval,pval
              rad(j) = rval
              phi(i) = pval
           end if
           dum = rad(j-1)
           area(j,i) = (rval*rval-dum*dum)*thwidth*0.5_prc ! polargrid area
!!$---------------------------------------------------------------------
!!$     Read values only at the specified lambda and convert the polar 
!!$     coordinates of the grid, (rad(j), phi(i)), into the cartesian 
!!$     coordinates, (xx(j,i), yy(j,i)).  Also, convert intensity from
!!$     erg s^-1 cm^-2 Hz^-1 sr^-1 to mJy arcsec^-2.
!!$---------------------------------------------------------------------
!!$         xx(j,i) runs from -Rmax to Rmax (in arcsec)
!!$         yy(j,i) runs from     0 to Rmax (in arcsec)
!!$---------------------------------------------------------------------
           do k=1,nwav
              if (k == nlam) then
                 read(10,*) lam(nl),tau(j,i),flux(j,i)
                 flux(j,i) = flux(j,i)*2.35044305391E+15_prc 
                 xx(j,i) = rad(j) * sin(phi(i))
                 yy(j,i) = rad(j) * cos(phi(i))
              else 
                 read(10,*) dum,dum,dum
              end if
           end do
        end do
     end do
     close(10)
!!$---------------------------------------------------------------------
!!$  Find the maximum and minimum values along the cartesian grids
!!$---------------------------------------------------------------------
     xmax=MAXVAL(xx)
     xmin=MINVAL(xx)
     ymax=MAXVAL(yy)
     ymin=MINVAL(yy)
!!$  write(55,'(4es22.14)') xmax,xmin,ymax,ymin
!!$  do i=1,nphi
!!$     do j=1,nrad
!!$        write(55,'(2es22.14)') xx(j,i),yy(j,i)
!!$     end do
!!$  end do
!!$---------------------------------------------------------------------
!!$  Done reading input file
!!$---------------------------------------------------------------------

!!$---------------------------------------------------------------------
!!$  Transfer flux/optical depth values in the polar grids into the 
!!$  corresponding cartesian grids.
!!$---------------------------------------------------------------------
!!$    Determine the corresponding grids
!!$---------------------------------------------------------------------
!!$      For a given polar grid, figure out where in the Cartesian grid 
!!$      it would fall on.  
!!$
!!$      Then, for each Cartesian grid, we do bookkeeping of;
!!$        imagebox1 : sum of intensities    (mJy arcsec^-2)
!!$        imagebox2 : sum of optical depths
!!$        imagebox3 : sum of fluxes         (mJy)
!!$        imagebox4 : sum of optical depths * area
!!$        npts1     : number of polar grid values in the cartesian grid
!!$        flag1     : = 1 if pixel has a value and = 0 if empty 
!!$        totarea   : total polar grid area tjat has fallen onto the
!!$                    cartesian grid
!!$---------------------------------------------------------------------
     xpixmax    = imxsize + ANINT(xsearchbox*0.5_prc)
     xpixmin    = -ANINT(xsearchbox*0.5_prc)
     ypixmax    = imysize + ANINT(ysearchbox*0.5_prc)
     ypixmin    = -ANINT(ysearchbox*0.5_prc)
     allocate(imagebox1(xpixmin:xpixmax,ypixmin:ypixmax))
     allocate(imagebox2(xpixmin:xpixmax,ypixmin:ypixmax))
     allocate(imagebox3(xpixmin:xpixmax,ypixmin:ypixmax))
     allocate(imagebox4(xpixmin:xpixmax,ypixmin:ypixmax))
     allocate(npts1(xpixmin:xpixmax,ypixmin:ypixmax))
     allocate(flag1(xpixmin:xpixmax,ypixmin:ypixmax))
     allocate(totarea(xpixmin:xpixmax,ypixmin:ypixmax))
     imagebox1 = 0.0_prc
     imagebox2 = 0.0_prc
     imagebox3 = 0.0_prc
     imagebox4 = 0.0_prc
     npts1     = 0
     flag1     = 0
     totarea   = 0.0_prc
     do i=1,nphi
        do j=1,nrad
           do k=1,2 ! for +/- regions of y space
              p    = xx(j,i)/xpixscale + imxsize*0.5_prc
              q    = (-1.0)**k * yy(j,i)/ypixscale + imysize*0.5_prc
              xpix = ANINT(p-0.5)
              ypix = ANINT(q-0.5)
              if ((xpix>=xpixmin .AND. xpix<=xpixmax) .AND. &
                   (ypix>=ypixmin .AND. ypix<=ypixmax)) then
                 imagebox1(xpix,ypix) = imagebox1(xpix,ypix) + flux(j,i)
                 imagebox3(xpix,ypix) = imagebox3(xpix,ypix) + &
                      flux(j,i)*area(j,i)
                 imagebox2(xpix,ypix) = imagebox2(xpix,ypix) + tau(j,i)
                 imagebox4(xpix,ypix) = imagebox4(xpix,ypix) + &
                      tau(j,i)*area(j,i)
                 npts1(xpix,ypix)     = npts1(xpix,ypix)     + 1
                 totarea(xpix,ypix)   = totarea(xpix,ypix)   + area(j,i)
                 flag1(xpix,ypix)     = 1
              end if
           end do
        end do
     end do
!!$---------------------------------------------------------------------
!!$  Done transferring polar grid values to the Cartesian grid
!!$---------------------------------------------------------------------

!!$---------------------------------------------------------------------
!!$  Determine the pixel values in the Cartesian grid
!!$---------------------------------------------------------------------
!!$    Loop through all pixels in the output image
!!$      (1) if values exist then take average
!!$      (2) if value does not exist then interpolates from nearby
!!$          (a) find valued pixels in the search box
!!$          (b) sort them in order of the distance (from the closest)
!!$          (c) use minimum number of vicinity pixels to interpolate
!!$---------------------------------------------------------------------
     count1 = 0
     count2 = 0
     allocate(pix(imxsize,imysize))
     allocate(fluxpix(imxsize,imysize))
     allocate(taupix(imxsize,imysize))
     maxnum = xsearchbox*ysearchbox
     allocate(ds2(0:maxnum))
     allocate(val1(maxnum))
     allocate(val2(maxnum))
     ds2    = float(xsearchbox*ysearchbox/4)
     ds2(0) = 0.0_prc 
     do i=1,imxsize
        do j=1,imysize
           if (flag1(i,j) == 1) then
!!$---------------------------------------------------------------------
!!$     When the current cartesian grid has polar grid values, calculate
!!$     area-averaged intensity and optical depth for that grid.
!!$---------------------------------------------------------------------
              fluxpix(i,j) = imagebox3(i,j)/totarea(i,j)
              taupix(i,j)  = imagebox4(i,j)/totarea(i,j)
!!$           write(51,*) i,j,fluxpix(i,j),taupix(i,j)
!!$---------------------------------------------------------------------
!!$     When the current cartesian grid has no polar grid value, try
!!$     interpolating the pixel value using nearby non empty pixels.
!!$---------------------------------------------------------------------
           else
              val1   = 0.0_prc
              val2   = 0.0_prc
              count1 = count1  + 1
              kstart = xpixmin + i
              lstart = ypixmin + j
              num    = 0
!!$---------------------------------------------------------------------
!!$        loop through within the "searchbox"
!!$---------------------------------------------------------------------
!!$          tmpds2: distance (squared) between the current pixel and 
!!$                  the present searchbox pixel
!!$          ds2   : distances (squared) for the searchbox pixels to be
!!$                  used in interporation (max is half the searchbox
!!$                  size)
!!$          val1  : area-averaged flux for the searchbox pixel to be
!!$                  used in interporation
!!$          val2  : area-averaged opt. depth for the searchbox pixel
!!$                  to be used in interporation
!!$---------------------------------------------------------------------
              do k=kstart+1,kstart+xsearchbox
                 do l=lstart+1,lstart+ysearchbox
                    if (flag1(k,l) == 1) then
!!$---------------------------------------------------------------------
!!$              if a value exists in the searchbox get the distance
!!$              from the current pix to the current searchbox
!!$---------------------------------------------------------------------
                       tmpds2 = (i-k)*(i-k)+(j-l)*(j-l)
                       if (tmpds2 < ds2(maxnum)) then
!!$---------------------------------------------------------------------
!!$                 if the pixel is within the allowed search radius
!!$                 get flux/opt. depth values from the searchbox pixel
!!$---------------------------------------------------------------------
                          m       = num + 1 ! temporaliry update counter
                          ds2(m)  = tmpds2
                          val1(m) = imagebox3(k,l) / totarea(k,l)
                          val2(m) = imagebox4(k,l) / totarea(k,l)
                          num     = m       ! update counter
                          if (m > 1) then
!!$---------------------------------------------------------------------
!!$                    if there are more than one values to be used for
!!$                    interpolation, sort the ds2, val2, and val2
!!$                    arrays in order of distance
!!$---------------------------------------------------------------------
                             do ! sort the ds2, val1, and val2 arrays
                                oldds2  = ds2(m-1) 
                                if (tmpds2 >= oldds2) then
                                   exit
                                else
                                   tmpds22   = ds2(m)
                                   tmpval1   = val1(m)
                                   tmpval2   = val2(m)
                                   ds2(m)    = ds2(m-1)
                                   val1(m)   = val1(m-1)
                                   val2(m)   = val2(m-1)
                                   ds2(m-1)  = tmpds22
                                   val1(m-1) = tmpval1
                                   val2(m-1) = tmpval2
                                   m         = m - 1
                                end if
                             end do
                          end if
                       end if
                    end if
                 end do
              end do
!!$---------------------------------------------------------------------
!!$        The nearby, non-empty pixels are found.  Do interpolation.
!!$---------------------------------------------------------------------
!!$          num  = number of non-empty pixels in the vicinity
!!$          val1 = flux values in the nearby pixels (area-averaged)
!!$          val2 = tau values in the nearby pixels (area-averaged)
!!$          ds2  = distance squared
!!$---------------------------------------------------------------------
              if (num /= 0) then ! when non-empty pixels are found
                 sum1 = 0.0_prc
                 sum2 = 0.0_prc
                 wgt  = 0.0_prc
!!$---------------------------------------------------------------------
!!$           calculate the interpolated pixel value giving weights
!!$           based on the distance from the current pixel
!!$
!!$           however, the maximum number of values used in the 
!!$           interpolation is limited by the number of vicinity cells
!!$           found from (1,1) within search radius "ds2".
!!$---------------------------------------------------------------------
                 if (i == 1 .AND. j == 1) minnum = num
                 do k=1,minnum
                    dum  = 1.0_prc / ds2(k)
                    sum1 = sum1 + val1(k) * dum
                    sum2 = sum2 + val2(k) * dum
                    wgt  = wgt + dum
!!$                 write(51,*) val1(k),val2(k),dum
                 end do
                 fluxpix(i,j) = sum1 / wgt
                 taupix(i,j)  = sum2 / wgt
!!$              write(51,*) i,j,fluxpix(i,j),taupix(i,j)
              else ! if there is still no pixel value
                 count2 = count2 + 1
!!$              write(51,*) i,j,fluxpix(i,j),taupix(i,j)
              end if
           end if
        end do
     end do
!!$---------------------------------------------------------------------
!!$  Display summary and output
!!$---------------------------------------------------------------------
     if (iflag /= 0) then
        write(*,'(" Interpolation summary ")')
        write(*,'("  ")')
        write(*,'("   Number of pixels:                   ",i8)') &
             imxsize*imysize
        write(*,'("   Number of zero value pixels before: ",i8)') count1
        write(*,'("   Number of zero value pixels after:  ",i8)') count2
     end if
     num = LEN_TRIM(infile)
     outfile1 = infile
     outfile2 = infile
     write(dummy1,'(g9.4)')lam(nl)
     write(dummy2,'(f5.3)')xpixscale
     dummy=dummy1(1:len_trim(dummy1))//".dat"
!!$     dummy=dummy1(1:len_trim(dummy1))//"_"//dummy2(1:len_trim(dummy2))//".dat"
     write(outfile1(num-3:num+15),'("f_",A)') dummy(1:len_trim(dummy))
     write(outfile2(num-3:num+15),'("t_",A)') dummy(1:len_trim(dummy))
!!$---------------------------------------------------------------------
!!$  Output flux is in mJy arcsec^-2
!!$---------------------------------------------------------------------
!!$    previously outputs are written in ascii
!!$---------------------------------------------------------------------
!!$     if (datflag.eq.'y' .or. datflag.eq.'Y') then
!!$       open(unit=11,file=outfile1)
!!$       open(unit=12,file=outfile2)
!!$       do i=1,imxsize
!!$          do j=1,imysize
!!$             write(11,*) fluxpix(i,j)
!!$             write(12,*) taupix(i,j)
!!$          end do
!!$       end do
!!$       close(11)
!!$       close(12)
!!$     endif
!!$---------------------------------------------------------------------
!!$    now output to fits
!!$---------------------------------------------------------------------
     outfile1=outfile1(1:len_trim(outfile1)-3)//"fits"
     outfile2=outfile2(1:len_trim(outfile2)-3)//"fits"
     status=0
     naxes(1)=imxsize
     naxes(2)=imysize
     num=naxes(1)*naxes(2)
     !
     call ftgiou(oim,status)
     !
     call ftopen(oim,outfile1,1,blocksize,status)
     if (status .eq. 0)then !file was opened;  so now delete it 
        call ftdelt(oim,status)
     else if (status .eq. 103)then ! file doesn't exist
        status=0
        call ftcmsg
     else ! there was some other error; delete anyway
        status=0
        call ftcmsg
        call ftdelt(oim,status)
     end if
!!$
     call ftinit(oim,outfile1,1,status)
     call ftphpr(oim,.true.,-32,2,naxes,0,1,.true.,status)
     call ftpkyd(oim,'SECPPIX',xpixscale,3,'arcsec per pixel',status)
     call ftpkyd(oim,'LAMBDA',lam(nl),3,'wavelength of image',status)
     call ftpkys(oim,'TYPE','Flux','mJy/arcsec^2',status)
!!$
     if (ierror==0) then
        call ftpkyj(oim,'NRAD',nr,' ',status)
        call ftpkyj(oim,'NQ',nq,' ',status)
        call ftpkyj(oim,'MXSTEP',mxstep,' ',status)
        call ftpkyd(oim,'VSPACE',vspace,3,' ',status)
        call ftpkyj(oim,'DFLAG',dflag,' ',status)
        call ftpkyj(oim,'SFLAG',sflag,' ',status)
        call ftpkyj(oim,'BFLAG',bflag,' ',status)
        call ftpkyd(oim,'RSTAR',rstar,3,' ',status)
        call ftpkyd(oim,'TSTAR',tstar,3,' ',status)
        call ftpkyd(oim,'DISTANCE',distance,3,' ',status)
        call ftpkyd(oim,'VELOCITY',velocity,3,' ',status)
        call ftpkyd(oim,'A',a,3,' ',status)
        call ftpkyd(oim,'B',b,3,' ',status)
        call ftpkyd(oim,'C',c,3,' ',status)
        call ftpkyd(oim,'D',d,3,' ',status)
        call ftpkyd(oim,'E',e,3,' ',status)
        call ftpkyd(oim,'F',f,3,' ',status)
        call ftpkyd(oim,'TAU0',tau0,3,' ',status)
        call ftpkyd(oim,'RMIN',f1,3,' ',status)
        call ftpkyd(oim,'RMAX',f2,3,' ',status)
        call ftpkyd(oim,'RSW',f3,3,' ',status)
        call ftpkyj(oim,'N0',n0,' ',status)
        call ftpkyj(oim,'NZONE',nzone,' ',status)
        do i=0,nzone,1
           write(dummy(1:7),'("RLAYER",1i1)') i
           call ftpkyd(oim,dummy(1:7),rlayer(i),3,' ',status)
        enddo
     endif
!!$
     do i=1,imxsize
        do j=1,imysize
           pix(j,i)=fluxpix(i,j)
        end do
     end do
     call ftpprd(oim,1,1,num,pix,status)
     call ftclos(oim,status)
     call ftfiou(oim,status)
!!$
     call ftgiou(oim,status)
!!$
     call ftopen(oim,outfile2,1,blocksize,status)
     if (status .eq. 0)then !file was opened;  so now delete it 
        call ftdelt(oim,status)
     else if (status .eq. 103)then ! file doesn't exist
        status=0
        call ftcmsg
     else ! there was some other error; delete anyway
        status=0
        call ftcmsg
        call ftdelt(oim,status)
     end if
!!$
     call ftinit(oim,outfile2,1,status)
     call ftphpr(oim,.true.,-32,2,naxes,0,1,.true.,status)
     call ftpkyd(oim,'SECPPIX',xpixscale,3,'arcsec per pixel',status)
     call ftpkyd(oim,'LAMBDA',lam(nl),3,'wavelength of image',status)
     call ftpkys(oim,'TYPE','Tau','optical depth',status)
     do i=1,imxsize
        do j=1,imysize
           pix(j,i)=fluxpix(i,j)
        end do
     end do
     call ftpprd(oim,1,1,num,pix,status)
     call ftclos(oim,status)
     call ftfiou(oim,status)
!!$
     num = LEN_TRIM(outfile1)
     if (iflag /= 0) then
        write(*,'(" ")')
        write(*,'("  Output flux map is ",A)') outfile1(1:num) 
        write(*,'("  Output tau map is  ",A)') outfile2(1:num) 
        write(*,'(" ")')
     end if
!!$
     deallocate(imagebox1,imagebox2,imagebox3,imagebox4,npts1,flag1, &
          totarea,pix,fluxpix,taupix,ds2,val1,val2)
  end do
  if (iflag /= 0) write(*,'(" DONE! ")')
!!$---------------------------------------------------------------------
!!$  Done making maps!
!!$---------------------------------------------------------------------
  deallocate(rad,phi,flux,tau,xx,yy,area,numwav,lam)
end program mapgrid

!!$---------------------------------------------------------------------
SUBROUTINE BBTABGEN(FREQ,WT3,KAPPA,NWAV,NZONE,TTABLE,BTABLE)
!!$---------------------------------------------------------------------
!!$  This subroutine computes a table of the frequency integral of 
!!$  kappa*Planck function versus temperature.  This table is used in 
!!$  the main radiative transfer programs to determine local temperature 
!!$  by requiring radiative equilibrium.  The integral is performed 
!!$  using a step-function-type integration.
!!$---------------------------------------------------------------------
  USE DEFVARS
!!$---------------------------------------------------------------------
  IMPLICIT NONE
!!$---------------------------------------------------------------------
  INTEGER,   INTENT(IN)                            :: NWAV,NZONE
!!$---------------------------------------------------------------------
  REAL(PRC), INTENT(IN),  DIMENSION(NWAV)          :: FREQ,WT3
  REAL(PRC), INTENT(IN),  DIMENSION(NWAV,NZONE)    :: KAPPA
  REAL(PRC), INTENT(OUT), DIMENSION(NGRID+1)       :: TTABLE
  REAL(PRC), INTENT(OUT), DIMENSION(NGRID+1,NZONE) :: BTABLE
!!$---------------------------------------------------------------------
  REAL(PRC) :: DELTA,T,AA,BB,FQ
  REAL(PRC), DIMENSION(NZONE) :: DUM
!!$---------------------------------------------------------------------
  INTEGER :: I,II,J,IOFLAG,IERROR
!!$---------------------------------------------------------------------
  OPEN(UNIT=30,FILE='datafiles.dat',STATUS='OLD',IOSTAT=IERROR)
  READ(30,*) IOFLAG
  CLOSE(30)
!!$
  IF (IOFLAG == 0) THEN
     WRITE(6,'(" Generating the T & kappa*B(T) tables...  ")')
     WRITE(6,'("  ")')
  ENDIF
!!$
  DELTA = LOG10(TTOP/TBOT) / REAL(NGRID)  
  DO I = 1,NGRID+1
     T = TBOT * (10.0_PRC**(REAL(I-1) * DELTA))
     TTABLE(I) = T
     DUM = 0.0_PRC
     DO II = 1,NWAV
        FQ = FREQ(II) 
        AA = C3 * FQ / T
        IF (AA <= 85.0_PRC) THEN
           IF (AA >= 1.0E-06_PRC) THEN
              AA = EXP(-AA)
              BB = C2*FQ*FQ*FQ*AA/(1.0_PRC-AA)
           ELSE
              BB = C2*FQ*FQ*FQ/AA ! Rayleigh limit
           END IF
        ELSE
           BB = 0.0_PRC           ! Wien limit
        END IF
        DO J = 1,NZONE
           DUM(J) = DUM(J) + C1*WT3(II)*KAPPA(II,J)*BB
        END DO
     END DO
     DO J=1,NZONE
        BTABLE(I,J) = DUM(J)
     END DO
  END DO
END SUBROUTINE BBTABGEN

!!$---------------------------------------------------------------------
SUBROUTINE BBTABGEN2(FREQ,WT3,NWAV,NZONE,MXTY,TTABLE,SDTYPE,&
     RHOGR,NUMWT,GAMMA2,QABS,QSCA,GEEE,APTS,AWTS,BTABLE2)
!!$---------------------------------------------------------------------
!!$  This subroutine computes a table of the frequency integral of 
!!$  kappa*Planck function versus temperature.  This table is used in 
!!$  the main radiative transfer programs to determine local temperature 
!!$  by requiring radiative equilibrium.  The integral is performed 
!!$  using a step-function-type integration.
!!$---------------------------------------------------------------------
  USE DEFVARS
!!$---------------------------------------------------------------------
  IMPLICIT NONE
!!$---------------------------------------------------------------------
  INTEGER,   INTENT(IN)                     :: NWAV,NZONE,MXTY
!!$---------------------------------------------------------------------
  REAL(PRC), INTENT(IN), DIMENSION(NWAV)    :: FREQ,WT3
  REAL(PRC), INTENT(IN), DIMENSION(NGRID+1) :: TTABLE
!!$---------------------------------------------------------------------
  INTEGER,   INTENT(OUT), DIMENSION(MXTY,NZONE) :: SDTYPE
  REAL(PRC), INTENT(OUT), DIMENSION(MXTY,NZONE) :: RHOGR,NUMWT,GAMMA2
  REAL(PRC), INTENT(OUT), DIMENSION(NWAV,NSIZE,MXTY,NZONE)    :: QABS
  REAL(PRC), INTENT(OUT), DIMENSION(NWAV,NSIZE,MXTY,NZONE)    :: QSCA
  REAL(PRC), INTENT(OUT), DIMENSION(NWAV,NSIZE,MXTY,NZONE)    :: GEEE
  REAL(PRC), INTENT(OUT), DIMENSION(0:NSIZE+1,MXTY,NZONE)     :: APTS
  REAL(PRC), INTENT(OUT), DIMENSION(NSIZE,MXTY,NZONE)         :: AWTS
  REAL(PRC), INTENT(OUT), DIMENSION(NGRID+1,NSIZE,MXTY,NZONE) :: BTABLE2
!!$---------------------------------------------------------------------
  REAL(PRC) :: T,AA,BB,DUM,FQ
!!$---------------------------------------------------------------------
  INTEGER :: I,IOFLAG,IERROR,NZ,NG,NS,NW,PLEN
!!$---------------------------------------------------------------------
  INTEGER, ALLOCATABLE, DIMENSION(:) :: NGTYPE
!!$---------------------------------------------------------------------
  CHARACTER(30) :: PROPS,DUMMY
!!$---------------------------------------------------------------------
!!$  Read datailes.dat
!!$---------------------------------------------------------------------
  OPEN(UNIT=30,FILE='datafiles.dat',STATUS='OLD',IOSTAT=IERROR)
  READ(30,*) IOFLAG
  READ(30,'(A)') DUMMY
  READ(30,'(A)') DUMMY
  READ(30,'(A)') DUMMY
  READ(30,'(A)') DUMMY
  READ(30,'(A)') PROPS ! dust grain properties file
  CLOSE(30)
!!$---------------------------------------------------------------------
!!$ Read dust properties file, PROPS
!!$---------------------------------------------------------------------
  PLEN = LEN_TRIM(PROPS)
  WRITE(PROPS(PLEN+1:PLEN+4),'(".dat")')
  ALLOCATE(NGTYPE(NZONE),STAT=IERROR)
  OPEN(UNIT=30,FILE=PROPS,STATUS='old',IOSTAT=IERROR)
  READ(30,*) DUMMY       ! skip other things for now
  DO NZ=1,NZONE ! Just read NGTYPE, repeating NZ times
     READ(30,*) NGTYPE(NZ)
     DO NG=1,NGTYPE(NZ)
        READ(30,*) DUMMY ! skip other things for now
     END DO
  END DO
  CLOSE(30)
!!$---------------------------------------------------------------------
!!$  Read SizeQ.dat to get size-dependent Q values
!!$---------------------------------------------------------------------
  OPEN(UNIT=30,FILE="SizeQ.dat",STATUS='unknown',IOSTAT=IERROR)
  DO NZ=1,NZONE
     DO NG=1,NGTYPE(NZ)
        READ(30,*) SDTYPE(NG,NZ),RHOGR(NG,NZ),NUMWT(NG,NZ), &
             GAMMA2(NG,NZ)
        READ(30,*) APTS(0,NG,NZ)
        DO NS=1,NSIZE
           READ(30,*) APTS(NS,NG,NZ),AWTS(NS,NG,NZ)
           READ(30,*) (QABS(NW,NS,NG,NZ),NW=1,NWAV)
           READ(30,*) (QSCA(NW,NS,NG,NZ),NW=1,NWAV)
           READ(30,*) (GEEE(NW,NS,NG,NZ),NW=1,NWAV)
        END DO
        READ(30,*) APTS(NSIZE+1,NG,NZ)
     END DO
  END DO
  CLOSE(30)
!!$---------------------------------------------------------------------
  IF (IOFLAG == 0) THEN
     WRITE(6,'(" Generating the EXTENDED T & kappa*B(T) table...  ")')
     WRITE(6,'("  ")')
  ENDIF
!!$
  BTABLE2 = 0.0_PRC
  DO NZ = 1, NZONE
     DO NG = 1, NGTYPE(NZ)
        DO NS = 1, NSIZE
           DO I = 1, NGRID+1
              T   = TTABLE(I)
              DUM = 0.0_PRC
              DO NW = 1, NWAV
                 FQ = FREQ(NW)
                 AA = C3 * FQ / T
                 IF (AA <= 85.0_PRC) THEN
                    IF (AA >= 1.0E-06_PRC) THEN
                       AA = EXP(-AA)
                       BB = C2*FQ*FQ*FQ*AA/(1.0_PRC-AA)
                    ELSE
                       BB = C2*FQ*FQ*FQ/AA ! Rayleigh limit
                    END IF
                 ELSE
                    BB = 0.0_PRC           ! Wien limit
                 END IF
                 AA  = APTS(NS,NG,NZ)
                 DUM = DUM+C1*WT3(NW)*AA*AA*QABS(NW,NS,NG,NZ)*BB
              END DO
              BTABLE2(I,NS,NG,NZ) = DUM
           END DO
        END DO
     END DO
  END DO
  DEALLOCATE(NGTYPE,STAT=IERROR)
END SUBROUTINE BBTABGEN2
